// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_entities.djinni

#import "VFIDecimal.h"
#import <Foundation/Foundation.h>
@class VFIAmountTotals;


/** A container for the various totals. */
@interface VFIAmountTotals : NSObject

/**
 * Create an amount totals object. If unset is true, then none of the amounts
 * default to 0, otherwise the total and possibly other values will be set to 0.
 */
+ (nullable VFIAmountTotals *)create:(BOOL)unset;

/** Returns the subtotal if set, otherwise returns null. */
- (nullable VFIDecimal *)getSubtotal;

/** Returns the general tax if set, otherwise returns null. */
- (nullable VFIDecimal *)getTax;

/** Returns the amount that is being paid as a tip or gratuity if set, otherwise returns null. */
- (nullable VFIDecimal *)getGratuity;

/** Returns the amount that is being paid as fees if set, otherwise returns null. */
- (nullable VFIDecimal *)getFees;

/** Returns the amount that is being paid as donation if set, otherwise returns null. */
- (nullable VFIDecimal *)getDonation;

/** Returns the amount that is being returned as cashback if set, otherwise returns null. */
- (nullable VFIDecimal *)getCashback;

/**
 * Returns the grand total, which is (subtotal + tax(es) + gratuity + any other amounts)
 * if set, otherwise returns null.
 */
- (nullable VFIDecimal *)getTotal;

/**
 * Returns true if all of getTotal(), getSubtotal(), getTax(),
 * getGratuity(), and getTaxesWithCodes() are null.
 */
- (BOOL)isUnset;

/**
 * Returns the actual instance for the map that stores the taxes
 * and codes. This object is not
 * thread-safe.
 */
- (nonnull NSDictionary<NSString *, VFIDecimal *> *)getTaxesWithCodes;

/** Set all of the amounts at once, overriding any previous setting. */
- (void)setWithAmounts:(nullable VFIDecimal *)subtotal
                   tax:(nullable VFIDecimal *)tax
              gratuity:(nullable VFIDecimal *)gratuity
                  fees:(nullable VFIDecimal *)fees
              cashback:(nullable VFIDecimal *)cashback
              donation:(nullable VFIDecimal *)donation
                 total:(nullable VFIDecimal *)total;

/**
 * Sets the subtotal, which normally does not include taxes and gratuity depending on the region.
 * This is optional but highly recommended.
 */
- (void)setSubtotal:(nullable VFIDecimal *)subtotal;

/**
 * Sets the general tax amount. Acts as a wrapper for calling
 * {@link #addTaxWithCode(String, BigDecimal)} with a null tax code. This
 * should not be used in conjunction with {@link #setTaxesWithCodes(HashMap)}.
 */
- (void)setTax:(nullable VFIDecimal *)tax;

/** Sets the amount that is being paid as a tip or gratuity. */
- (void)setGratuity:(nullable VFIDecimal *)gratuity;

/**
 * Set the amount of cashback  as a GAAP-standard BigDecimal.
 * This may also refer to a cash advance amount, based on the payment type.
 */
- (void)setCashback:(nullable VFIDecimal *)cashback;

/** Set the amount of fees  as a GAAP-standard BigDecimal. */
- (void)setFees:(nullable VFIDecimal *)fees;

/** Set the amount of donations  as a GAAP-standard BigDecimal. */
- (void)setDonation:(nullable VFIDecimal *)donation;

/** Sets the grand total, which is (subtotal + tax(es) + gratuity + any other amounts). */
- (void)setTotal:(nullable VFIDecimal *)total;

/**
 * Sets the taxes with codes all at once. Use either this or
 * {@link #addTaxWithCode(String, BigDecimal)}.
 */
- (void)setTaxesWithCodes:(nonnull NSDictionary<NSString *, VFIDecimal *> *)taxesWithCodes;

/**
 * Inserts this amount for this code if it is not already present,
 * or replaces it if the tax code is already present. If the amount is null,
 * removes the tax code from the map if it exists, otherwise it does nothing.
 * If the tax code is null, the amount is considered to be the total tax being applied.
 */
- (void)addTaxWithCode:(nonnull NSString *)taxCode
             taxAmount:(nullable VFIDecimal *)taxAmount;

/** Adds the specified values to the existing values. */
- (void)addAmounts:(nullable VFIDecimal *)subtotal
               tax:(nullable VFIDecimal *)tax
          gratuity:(nullable VFIDecimal *)gratuity
              fees:(nullable VFIDecimal *)fees
          cashback:(nullable VFIDecimal *)cashback
          donation:(nullable VFIDecimal *)donation
             total:(nullable VFIDecimal *)total;

/** Subtracts the specified values from the existing values. */
- (void)subtractAmounts:(nullable VFIDecimal *)subtotal
                    tax:(nullable VFIDecimal *)tax
               gratuity:(nullable VFIDecimal *)gratuity
                   fees:(nullable VFIDecimal *)fees
               cashback:(nullable VFIDecimal *)cashback
               donation:(nullable VFIDecimal *)donation
                  total:(nullable VFIDecimal *)total;

@end
