// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_entities.djinni

#import <Foundation/Foundation.h>
@class VFIBasket;
@class VFIDonation;
@class VFIMerchandise;
@class VFIOffer;


/**
 * Represents all of the items that have been added to the basket. Adding items
 * should generally be performed through the {@link com.verifone.payment_sdk.BasketManager},
 * so that the display is updated and the appropriate events are sent. This
 * object is useful to store the current basket, save it for later, then quickly
 * restore all of the items to the screen, in case an order is put on hold and
 * then retrieved. See {@link com.verifone.payment_sdk.BasketManager#registerBasket}
 * for the method to restore a basket to the screen.
 */
@interface VFIBasket : NSObject

+ (nullable VFIBasket *)create;

/** Refer to {@link #setLoyaltyId(String loyaltyId)} for more information. */
- (nullable NSString *)getLoyaltyId;

/**
 * Get the invoice Id associated with this transaction and basket,
 * which is intended to link a set of payments together.
 */
- (nullable NSString *)getInvoiceId;

/** Refer to {@link #setMerchandises(Merchandise[] merchandises)} for more information. */
- (nonnull NSArray<VFIMerchandise *> *)getMerchandise;

/** Refer to {@link #setOffers(Offer[] offers)} for more information. */
- (nonnull NSArray<VFIOffer *> *)getOffers;

/**
 * Get any donations associated with this basket. These may change
 * throughout the transaction.
 */
- (nonnull NSArray<VFIDonation *> *)getDonations;

/** Clears all of the items from this object. */
- (void)clear;

/**
 * The loyalty ID associated with this transaction and basket.
 * This is set by the initiator of the transaction as the probable ID, and
 * may be updated during the transaction process. This is optional.
 */
- (void)setLoyaltyId:(nullable NSString *)loyaltyId;

/**
 * Set the invoice Id associated with this transaction and basket,
 * which is intended to link a set of payments together.
 */
- (void)setInvoiceId:(nullable NSString *)invoiceId;

/**
 * The merchandise that is being purchased or returned. This
 * should only be set by the POS
 * or payment application. This is optional.
 */
- (void)setMerchandise:(nonnull NSArray<VFIMerchandise *> *)merchandise;

/**
 * Any offers associated with this basket. These may change
 * throughout the transaction.
 * This is optional.
 */
- (void)setOffers:(nonnull NSArray<VFIOffer *> *)offers;

/**
 * Any donations associated with this basket. These may change
 * throughout the transaction.
 * This is optional.
 */
- (void)setDonations:(nonnull NSArray<VFIDonation *> *)donations;

@end
