// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_payment.djinni

#import <Foundation/Foundation.h>
@class VFIBasket;
@class VFIBasketAdjustedEventResponse;
@class VFIBasketAdjustment;
@class VFITransaction;

/** The constant event type for basket adjustment event. */
extern NSString * __nonnull const VFIBasketAdjustedEventTYPE;

/**
 * When the basket is adjusted by other applications in response to the
 * {@link com.verifone.commerce.triggers.BasketAdjustmentRequest} Trigger, this event is sent to
 * allow the recipient to decide which adjustments will be actually applied and which will not.
 */
@interface VFIBasketAdjustedEvent : NSObject

/** Returns the message associated with the event, */
- (nullable NSString *)getMessage;

/** Get the session ID for the session which triggered this event. */
- (nullable NSString *)getSessionId;

/**
 * Returns the response type, generally a copy of the event type, or otherwise linked to the
 * type of event that generated this response.
 */
- (nullable NSString *)getType;

/** Returns the status of the event, non-zero if it encountered an error during handling */
- (int32_t)getStatus;

/** Returns event id from event */
- (nullable NSString *)getEventId;

/** Returns invoice id from event */
- (nullable NSString *)getInvoiceId;

/** Return Transaction from event */
- (nullable VFITransaction *)getTransaction;

/** Get the original basket without adjustments. */
- (nullable VFIBasket *)getOriginalBasket;

/** Get the adjustments that are proposed. */
- (nullable VFIBasketAdjustment *)getAdjustments;

/**
 * Generates a Basket Adjusted Response object to send through
 * {@link TransactionManager#sendEventResponse(CommerceResponse)}.
 * @return The {@link Response} concrete class.
 */
- (nullable VFIBasketAdjustedEventResponse *)generateBasketAdjustedEventResponse;

@end
