// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_entities.djinni

#import <Foundation/Foundation.h>
@class VFIBasketAdjustment;
@class VFIDonation;
@class VFIOffer;


/**
 * Allows an application to propose changes to the basket using
 * {@link com.verifone.commerce.triggers.BasketAdjustmentResponse}.
 * When received in the {@link com.verifone.payment_sdk.BasketAdjustedEvent}, allows the
 * recipient to determine which adjustments will actually be applied to the cart.
 */
@interface VFIBasketAdjustment : NSObject

+ (nullable VFIBasketAdjustment *)create;

/** Returns true if any donations or offers have been added to the basket by the current application. */
- (BOOL)isBasketAdjusted;

/**
 * Retrieves all of the offers that have been added to this response. Creates an array backed
 * by the underlying list.
 */
- (nonnull NSArray<VFIOffer *> *)getOffers;

/** Retrieves all of the donations that have been added to this response. */
- (nonnull NSArray<VFIDonation *> *)getDonations;

/** Adds an offer. */
- (void)addOffer:(nullable VFIOffer *)offer;

/** Add list of offers to existed offers or create new list if no offers yet. */
- (void)addOffers:(nonnull NSArray<VFIOffer *> *)offers;

/** Removes an offer from the list if it is present. Only affects offers added by the current application. */
- (void)removeOffer:(nullable VFIOffer *)offer;

/** Adds a donation. */
- (void)addDonation:(nullable VFIDonation *)donation;

/** Add list of donations to existed donations or create new list if no donations yet. */
- (void)addDonations:(nonnull NSArray<VFIDonation *> *)donations;

/** Removes a donation from the list if it is present. Only affects donations added by the current application. */
- (void)removeDonation:(nullable VFIDonation *)donation;

/** Set basket adjusted (in case of offers, donations, etc.) */
- (void)setBasketAdjusted:(BOOL)adjusted;

@end
