// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_payment.djinni

#import <Foundation/Foundation.h>
@class VFICardInformation;
@class VFITransaction;
@class VFITransactionEventResponse;

/** Token query event type */
extern NSString * __nonnull const VFICardInformationReceivedEventTYPETOKENQUERY;
/** Card data event type */
extern NSString * __nonnull const VFICardInformationReceivedEventTYPECARDDATA;
/** Status code indicating that the card data was received successfully */
extern int32_t const VFICardInformationReceivedEventSUCCESS;
/** Status code indicating that the card needs to be removed from the chip card reader */
extern int32_t const VFICardInformationReceivedEventREMOVECARD;
/** Status code indicating that the card was removed from the chip card reader */
extern int32_t const VFICardInformationReceivedEventCARDREMOVED;
/**
 * Status code indicating that there was a timeout and no card was detected.
 * {@link TransactionManager#requestCardData(String, CardInformation.PresentationMethod[])} must
 * be called again after receiving an event with this status code to attempt detecting a card
 * again.
 */
extern int32_t const VFICardInformationReceivedEventTIMEOUTNOCARDDETECTED;
/**
 * Status code indicating that there was an error and the card should be presented again.
 * There is no need to call {@link TransactionManager#requestCardData(String, CardInformation.PresentationMethod[])}
 * again after receiving an event with this status code.
 */
extern int32_t const VFICardInformationReceivedEventPLEASETRYAGAIN;
/**
 * Status code indicating that the card should be presented in the chip card reader instead
 * There is no need to call {@link TransactionManager#requestCardData(String, CardInformation.PresentationMethod[])}
 * again after receiving an event with this status code.
 */
extern int32_t const VFICardInformationReceivedEventUSECHIPINSTEAD;
/**
 * Status code indicating that the card should be presented in the magnetic stripe reader instead
 * There is no need to call {@link TransactionManager#requestCardData(String, CardInformation.PresentationMethod[])}
 * again after receiving an event with this status code.
 */
extern int32_t const VFICardInformationReceivedEventUSEMSRINSTEAD;

/** Contains the value from customer input on the terminal. */
@interface VFICardInformationReceivedEvent : NSObject

/**
 * A user-readable message.
 * This message may not be localized, in which case the type field should be used for
 * determining a localized message.
 */
- (nullable NSString *)getMessage;

/** Get the session ID for the session which triggered this event. */
- (nullable NSString *)getSessionId;

/**
 * The type of status. This will generally be SUCCESS for a status of 0, and contain a
 * different type for other errors. For example, in a refund or void, it is possible to
 * receive type TRANSACTION_NOT_FOUND. This may be used for localizing the specific
 * messages as needed
 */
- (nullable NSString *)getType;

/**
 * Get the status for this particular event. A status of 0 means success,
 * any other status is a failure.
 */
- (int32_t)getStatus;

/**
 * Returns the event ID associated with this event. Useful for matching the event received by
 * the listener to the original status returned when issuing the call, for example, calling
 * {@link com.verifone.commerce.payment.TransactionManager#reprintReceipt(Payment)} returns a
 * CommerceEvent containing an event ID, which will match the event ID received by the
 * CommerceListener when the receipt reprint is complete. 
 */
- (nullable NSString *)getEventId;

/** The invoice ID for the transaction as a reference. */
- (nullable NSString *)getInvoiceId;

/** The transaction associated with this event. */
- (nullable VFITransaction *)getTransaction;

/**
 * Generate transaction event response for the current event.
 * @return empty response when a standard transaction event. Child classes may implement
 * appropriate responses as needed.
 */
- (nullable VFITransactionEventResponse *)generateTransactionEventResponse;

/** Returns full object with all available card information encapsulated. */
- (nullable VFICardInformation *)getCardInformation;

@end
