// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_payment.djinni

#import "VFIDeviceManagementAction.h"
#import <Foundation/Foundation.h>
@class VFITransaction;
@class VFITransactionEventResponse;

/** Device management event type */
extern NSString * __nonnull const VFIDeviceManagementEventTYPE;
/** ADE Blob data */
extern NSString * __nonnull const VFIDeviceManagementEventADEBLOBKEY;
/** VCL Track 1 data */
extern NSString * __nonnull const VFIDeviceManagementEventTRACK1KEY;
/** VCL Track 2 data */
extern NSString * __nonnull const VFIDeviceManagementEventTRACK2KEY;
/** VCL EPARMS data */
extern NSString * __nonnull const VFIDeviceManagementEventEPARMSKEY;
/** VSP Firmware Version */
extern NSString * __nonnull const VFIDeviceManagementEventVSPFIRMWAREVERSIONKEY;
/** VSP MDK Label */
extern NSString * __nonnull const VFIDeviceManagementEventMDKLABELKEY;
/** VSP Encryption State */
extern NSString * __nonnull const VFIDeviceManagementEventENCRYPTIONSTATEKEY;
/** VSP State */
extern NSString * __nonnull const VFIDeviceManagementEventVSPSTATEKEY;
/** VSP Mode */
extern NSString * __nonnull const VFIDeviceManagementEventVSPMODEKEY;
/** VSP BIN Table ID */
extern NSString * __nonnull const VFIDeviceManagementEventBINTABLEIDKEY;
/** VSP Encryption Algorithm */
extern NSString * __nonnull const VFIDeviceManagementEventENCRYPTIONALGORITHMKEY;
/** VSP operation mode */
extern NSString * __nonnull const VFIDeviceManagementEventOPERATIONMODEKEY;
/** VSP initial key id */
extern NSString * __nonnull const VFIDeviceManagementEventINITIALKEYIDKEY;
/** VSP config id */
extern NSString * __nonnull const VFIDeviceManagementEventCONFIGIDKEY;

/**
 * Received when a specific {@link DeviceManagementAction} has been sent to do something on the
 * payment terminal.
 */
@interface VFIDeviceManagementEvent : NSObject

/**
 * A user-readable message.
 * This message may not be localized, in which case the type field should be used for
 * determining a localized message.
 */
- (nullable NSString *)getMessage;

/** Get the session ID for the session which triggered this event. */
- (nullable NSString *)getSessionId;

/**
 * The type of status. This will generally be SUCCESS for a status of 0, and contain a
 * different type for other errors. For example, in a refund or void, it is possible to
 * receive type TRANSACTION_NOT_FOUND. This may be used for localizing the specific
 * messages as needed
 */
- (nullable NSString *)getType;

/**
 * Get the status for this particular event. A status of 0 means success,
 * any other status is a failure.
 */
- (int32_t)getStatus;

/**
 * Returns the event ID associated with this event. Useful for matching the event received by
 * the listener to the original status returned when issuing the call, for example, calling
 * {@link com.verifone.commerce.payment.TransactionManager#reprintReceipt(Payment)} returns a
 * CommerceEvent containing an event ID, which will match the event ID received by the
 * CommerceListener when the receipt reprint is complete. 
 */
- (nullable NSString *)getEventId;

/** The invoice ID for the transaction as a reference. */
- (nullable NSString *)getInvoiceId;

/** The transaction associated with this event. */
- (nullable VFITransaction *)getTransaction;

/**
 * Generate transaction event response for the current event.
 * @return empty response when a standard transaction event. Child classes may implement
 * appropriate responses as needed.
 */
- (nullable VFITransactionEventResponse *)generateTransactionEventResponse;

/** Get Device Management Action type */
- (VFIDeviceManagementAction)getActionType;

/**
 * Get mapped DeviceManagementEvent values based on
 * selected key values. Map includes VCL encryption 
 * such as track1, track2, and EPARMS values, as well
 * as VSP configuration values. Returns null if the
 * key is not present in the map.
 */
- (nullable NSString *)getValue:(nonnull NSString *)key;

@end
