// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from Employee.djinni

#import "VFIRoles.h"
#import <Foundation/Foundation.h>
@class VFIEmployee;


/** Represents an employee. */
@interface VFIEmployee : NSObject

+ (nullable VFIEmployee *)create;

/**
 * A unique, logical ID for the employee. This is consistent across devices,
 * and is separate from the internal _ID.
 */
- (nullable NSString *)getRecordId;

/** The full name of the employee. */
- (nullable NSString *)getName;

/**
 * The name for display or printing on the receipt.
 * This will generally be a shortened version of the full name.
 */
- (nullable NSString *)getDisplayName;

/** The roles associated with this employee. */
- (nonnull NSArray<NSNumber *> *)getRoles;

/** The timestamp of most recent login to this device */
- (nullable NSString *)getLastLoggedInTime;

/**
 * The timestamp of most recent logout out of this device
 * This may have been due to inactivity or explicitly logging out.
 */
- (nullable NSString *)getLastLoggedOutTime;

/**
 * The email address of the employee. This will return null if the employee does
 * not have an email address or if the requester does not have permission to read
 * the email address
 */
- (nullable NSString *)getEmailAddress;

/**
 * The phone number of the employee. This will return null if the employee does
 * not have a phone number or if the requester does not have permission to read
 * the phone number.
 */
- (nullable NSString *)getPhoneNumber;

/** Returns true if this employee is currently logged in. */
- (BOOL)isCurrentEmployee;

/** Performs login */
- (BOOL)login;

/** Performs logout */
- (BOOL)logout;

@end
