// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_host_adapter.djinni

#import "VFICardEncryptionType.h"
#import "VFIInstrumentType.h"
#import <Foundation/Foundation.h>

/**
 * The Payment Data object is introduced to reflect the nexo/ISO20022 structure that encapsulates
 * the data elements required to execute the required transaction, such as the Instrument used e.g.
 * card and the authentication details (e.g. the actual signature or the encrypted PIN block if
 * captured).
 */
@interface VFIHostPaymentData : NSObject
- (nonnull instancetype)initWithBillingStreet:(nullable NSString *)billingStreet
                                  billingCity:(nullable NSString *)billingCity
                    billingCountrySubdivision:(nullable NSString *)billingCountrySubdivision
                              billingPostCode:(nullable NSString *)billingPostCode
                               billingCountry:(nullable NSString *)billingCountry
                             pinEncrytpedData:(nullable NSString *)pinEncrytpedData
                           pinKeySerialNumber:(nullable NSString *)pinKeySerialNumber
                               instrumentType:(nullable NSNumber *)instrumentType
                             maskedCardNumber:(nullable NSString *)maskedCardNumber
                              cardDataEmvTags:(nullable NSDictionary<NSString *, NSString *> *)cardDataEmvTags
                               cardDataEparms:(nullable NSString *)cardDataEparms
                       cardDataEncryptionType:(nullable NSNumber *)cardDataEncryptionType
                               cardDataTrack2:(nullable NSString *)cardDataTrack2
                            cardDataTrack2Ksn:(nullable NSString *)cardDataTrack2Ksn
                                  cardDataPan:(nullable NSString *)cardDataPan
                               cardDataPanKsn:(nullable NSString *)cardDataPanKsn
                               cardDataExpiry:(nullable NSString *)cardDataExpiry
                            cardDataExpiryKsn:(nullable NSString *)cardDataExpiryKsn
                                  cardDataCvv:(nullable NSString *)cardDataCvv
                               cardDataCvvKsn:(nullable NSString *)cardDataCvvKsn
                                    cardBrand:(nullable NSString *)cardBrand
                                  cardproduct:(nullable NSString *)cardproduct;
+ (nonnull instancetype)HostPaymentDataWithBillingStreet:(nullable NSString *)billingStreet
                                             billingCity:(nullable NSString *)billingCity
                               billingCountrySubdivision:(nullable NSString *)billingCountrySubdivision
                                         billingPostCode:(nullable NSString *)billingPostCode
                                          billingCountry:(nullable NSString *)billingCountry
                                        pinEncrytpedData:(nullable NSString *)pinEncrytpedData
                                      pinKeySerialNumber:(nullable NSString *)pinKeySerialNumber
                                          instrumentType:(nullable NSNumber *)instrumentType
                                        maskedCardNumber:(nullable NSString *)maskedCardNumber
                                         cardDataEmvTags:(nullable NSDictionary<NSString *, NSString *> *)cardDataEmvTags
                                          cardDataEparms:(nullable NSString *)cardDataEparms
                                  cardDataEncryptionType:(nullable NSNumber *)cardDataEncryptionType
                                          cardDataTrack2:(nullable NSString *)cardDataTrack2
                                       cardDataTrack2Ksn:(nullable NSString *)cardDataTrack2Ksn
                                             cardDataPan:(nullable NSString *)cardDataPan
                                          cardDataPanKsn:(nullable NSString *)cardDataPanKsn
                                          cardDataExpiry:(nullable NSString *)cardDataExpiry
                                       cardDataExpiryKsn:(nullable NSString *)cardDataExpiryKsn
                                             cardDataCvv:(nullable NSString *)cardDataCvv
                                          cardDataCvvKsn:(nullable NSString *)cardDataCvvKsn
                                               cardBrand:(nullable NSString *)cardBrand
                                             cardproduct:(nullable NSString *)cardproduct;

/** Customer Billing Address Street */
@property (nonatomic, readonly, nullable) NSString * billingStreet;

/**
 * Customer Billing Address City
 *   Name of a built-up area, with defined boundaries, and a local government. This could be
 *   city or town.
 */
@property (nonatomic, readonly, nullable) NSString * billingCity;

/**
 * Customer Billing Address Country Subdivision
 *   Identifies a sub-division of a country which may be state, region or county.
 */
@property (nonatomic, readonly, nullable) NSString * billingCountrySubdivision;

/**
 * Customer Billing Address Postal Code
 *   Identifier consisting of a group of letters and/or numbers that is added to a postal
 *   address to assist the sorting of mail
 */
@property (nonatomic, readonly, nullable) NSString * billingPostCode;

/**
 * Customer Billing Address Country
 *   The ISO 3166-1 alpha-3 country code.
 */
@property (nonatomic, readonly, nullable) NSString * billingCountry;

/**
 * Encrypted PIN. (Personal Identification Number). The PIN data associated with the Card holder
 * or Customer (where known). This value should be an encrypted representation of the PIN. This
 * is attribute ISO8583 DE52. This value can never be persisted or logged.
 * Authentication Online PinData EncryptedPINBlock
 *   The encrypted PIN content as a string.
 */
@property (nonatomic, readonly, nullable) NSString * pinEncrytpedData;

/**
 * Authentication Online PinData EncryptedPINBlock
 *   The KSN is a constructed element that has multiple parts. In DUKPT 2009 this identification
 *   information is referred to as a Key Serial Number (KSN) sent by the initiator of the
 *   message to uniquely identify the derived key at the recipient. This is the first 5 bytes
 *   of the KSN. The structure should follow the standard:
 *
 *       Issuer Identification Number - 3 bytes
 *       Merchant ID - 1 byte
 *       Group ID - 1 byte
 *       Device ID - 19 bits
 *       Transaction Counter 21 bits.
 */
@property (nonatomic, readonly, nullable) NSString * pinKeySerialNumber;

/**
 * To identify the type of instrument whether it is a card, token or other...
 *  see {@link InstrumentType}
 */
@property (nonatomic, readonly, nullable) NSNumber * instrumentType;

/** The masked value for the Card Number. */
@property (nonatomic, readonly, nullable) NSString * maskedCardNumber;

/**
 * To identify the type of encryptionKey whether it is a Verifone keys, Acquirer/Customer keys
 * or none.
 */
@property (nonatomic, readonly, nullable) NSDictionary<NSString *, NSString *> * cardDataEmvTags;

/**
 * VCL AES-DUKPT encryption requires the use of eParms which is an additional blob of
 * encrypted data associated with the encrypted track data.
 */
@property (nonatomic, readonly, nullable) NSString * cardDataEparms;

/**
 * Encryption Type
 *   {@link #CardEncryptionType()}
 */
@property (nonatomic, readonly, nullable) NSNumber * cardDataEncryptionType;

/** <Encrypted Blob> Base-64 converted variable length blob. */
@property (nonatomic, readonly, nullable) NSString * cardDataTrack2;

/**
 * Track2 Key Serial Number
 *   NOTE: This is optional. If encryption is based on the encryption used
 */
@property (nonatomic, readonly, nullable) NSString * cardDataTrack2Ksn;

/** PAN - Used for Manual Entry */
@property (nonatomic, readonly, nullable) NSString * cardDataPan;

/**
 * PAN Key Serial Number - Used for Manual Entry
 *   NOTE: This is optional. If encryption is based on the encryption used
 */
@property (nonatomic, readonly, nullable) NSString * cardDataPanKsn;

/** Expiry - Used for Manual Entry */
@property (nonatomic, readonly, nullable) NSString * cardDataExpiry;

/**
 * Expiry Key Serial Number - Used for Manual Entry
 *   NOTE: This is optional. If encryption is based on the encryption used
 */
@property (nonatomic, readonly, nullable) NSString * cardDataExpiryKsn;

/** CVV - Used for Manual Entry */
@property (nonatomic, readonly, nullable) NSString * cardDataCvv;

/**
 * CVV Key Serial Number - Used for Manual Entry
 *   NOTE: This is optional. If encryption is based on the encryption used
 */
@property (nonatomic, readonly, nullable) NSString * cardDataCvvKsn;

/**
 * Represents a Card type or brand. It should correspond to a consistent name, the list of
 * constants is in {@link CardInformation}
 */
@property (nonatomic, readonly, nullable) NSString * cardBrand;

/**
 * The product name associated with the card brand. e.g. Classic, Standard, Gold, Platinum,
 * World. This must correspond to an actual product name.
 */
@property (nonatomic, readonly, nullable) NSString * cardproduct;

@end
