// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_host_adapter.djinni

#import "VFITransactionType.h"
#import <Foundation/Foundation.h>

/**
 * The transaction information. This will have multiple components describing the payment,
 * instrument/source, merchant and the sales context.
 */
@interface VFIHostTransaction : NSObject
- (nonnull instancetype)initWithReferenceId:(nullable NSString *)referenceId
                            transactionType:(nullable NSNumber *)transactionType
                               currencyCode:(nullable NSString *)currencyCode
                                totalAmount:(nullable NSString *)totalAmount
                             gratuityAmount:(nullable NSString *)gratuityAmount
                             cashbackAmount:(nullable NSString *)cashbackAmount
                             discountAmount:(nullable NSString *)discountAmount
                                  taxAmount:(nullable NSString *)taxAmount
                            createdDateTime:(nullable NSString *)createdDateTime
                                 merchantId:(nullable NSString *)merchantId
                                      poiId:(nullable NSString *)poiId
                                    poiName:(nullable NSString *)poiName
                            poiSerialNumber:(nullable NSString *)poiSerialNumber
                              poiDeviceType:(nullable NSString *)poiDeviceType;
+ (nonnull instancetype)HostTransactionWithReferenceId:(nullable NSString *)referenceId
                                       transactionType:(nullable NSNumber *)transactionType
                                          currencyCode:(nullable NSString *)currencyCode
                                           totalAmount:(nullable NSString *)totalAmount
                                        gratuityAmount:(nullable NSString *)gratuityAmount
                                        cashbackAmount:(nullable NSString *)cashbackAmount
                                        discountAmount:(nullable NSString *)discountAmount
                                             taxAmount:(nullable NSString *)taxAmount
                                       createdDateTime:(nullable NSString *)createdDateTime
                                            merchantId:(nullable NSString *)merchantId
                                                 poiId:(nullable NSString *)poiId
                                               poiName:(nullable NSString *)poiName
                                       poiSerialNumber:(nullable NSString *)poiSerialNumber
                                         poiDeviceType:(nullable NSString *)poiDeviceType;

/**
 * A client (user friendly) identifier for the transaction generated at the outset of a business
 * event. The format will be dependent on the calling system.
 *
 * A reference supplied by the system retaining the original source information and used to
 * assist in locating that transaction or a copy of the transaction. This value is critical in
 * matching values that are sent to other Payment processors or Acquirers. This value would
 * correspond to the ISO8583 specification as RRN in attribute DE 37, which limits the value to
 * being an alphanumeric value 12 characters.
 */
@property (nonatomic, readonly, nullable) NSString * referenceId;

/**
 * A type indicator for the main operation or service that was performed as part of the
 * transaction event.
 *
 * See {@link #TransactionType}
 */
@property (nonatomic, readonly, nullable) NSNumber * transactionType;

/** Three-letter ISO 4217 alphabetical currency code. e.g. USD. Values correspond to ISO 4217. */
@property (nonatomic, readonly, nullable) NSString * currencyCode;

/**
 * A amount type represented as money for all financial-related fields, such as balance,
 * payment due...
 */
@property (nonatomic, readonly, nullable) NSString * totalAmount;

/** The amount of gratuity or Tip if applicable. */
@property (nonatomic, readonly, nullable) NSString * gratuityAmount;

/** The amount of cashback. This is optional. */
@property (nonatomic, readonly, nullable) NSString * cashbackAmount;

/** The discount amount for the total quantity. */
@property (nonatomic, readonly, nullable) NSString * discountAmount;

/** The tax for this merchandise based on total quantity. */
@property (nonatomic, readonly, nullable) NSString * taxAmount;

/**
 * The time that the transaction occured at the POI/Terminal, this is referred to as the
 * acceptor datetime in ISO8583 specification DE 12. In some cases this may reflect the date
 * time when the transaction was received at a client Gateway or Switch where this is not
 * managed by Verifone. This format should include the necessary timezone information
 */
@property (nonatomic, readonly, nullable) NSString * createdDateTime;

/**
 * The Code identifying the card acceptor as issued by the Acquiring Institution. This may not
 * be unique across institutions. Also referred to as the MID. ISO8583 - DE 42
 */
@property (nonatomic, readonly, nullable) NSString * merchantId;

/**
 * The Code identifying the card accepting device as issued by the Acquiring Institution. This
 * may not be unique across institutions hence the use of a unique surrogate key. Also referred
 * to as the TID. ISO8583 - DE 41 or Terminal ID.
 *
 * This value will be validated against the authenticated Identity. So must match the range of
 * identifiers that have been allocated to the Merchant Entity who authenticates to the API.
 */
@property (nonatomic, readonly, nullable) NSString * poiId;

/**
 * The identifier used to represent this POI from an estate management perspective. This is not
 * the same as the TID which will be derived from the relationship with an Acquirer Agreement.
 */
@property (nonatomic, readonly, nullable) NSString * poiName;

/** A value to indicate the device serial number where known. */
@property (nonatomic, readonly, nullable) NSString * poiSerialNumber;

/**
 * The device type where transaction was captured, if known. This could be a model number or
 * other description e.g. VX690.
 */
@property (nonatomic, readonly, nullable) NSString * poiDeviceType;

@end
