// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_entities.djinni

#import <Foundation/Foundation.h>
@class VFILoyaltyAdjustment;
@class VFILoyaltyIdentifier;
@class VFIOffer;


/**
 * Contains the entire selection of adjustments that are valid for the current customer
 * using a specific Provider / Publisher.
 */
@interface VFILoyaltyAdjustment : NSObject

/** create LoyaltyAdjustment */
+ (nullable VFILoyaltyAdjustment *)create;

/** Publisher name. Identifies which platform is being used. */
- (nullable NSString *)getPublisher;

/** Publisher identifier. Provider may elect to pass a numeric identifier for their platform. */
- (nullable NSString *)getPublisherId;

/**
 * Array of Offers, see detailed description in {@link BasketAdjustmentRequest#getOffers()}.
 * @see BasketAdjustmentRequest#getOffers()
 */
- (nonnull NSArray<VFIOffer *> *)getLoyaltyOffers;

/**
 * The underlying list of offers.
 * @see #getLoyaltyOffers()
 */
- (nonnull NSArray<VFILoyaltyIdentifier *> *)getLoyaltyIdentifiers;

/** RFU */
- (nullable NSString *)getQrCodeString;

/** Sets the publisher name. This is required when creating a loyalty adjustment. */
- (void)setPublisher:(nullable NSString *)publisher;

/** Sets the publisher ID. */
- (void)setPublisherId:(nullable NSString *)publisherId;

/**
 * Set qr code string.
 * @see #getQrCodeString()
 */
- (void)setQrCodeString:(nullable NSString *)qrCodeString;

/**
 * Adds an offer.
 * @see #getLoyaltyOffers()
 */
- (void)addLoyaltyOffer:(nullable VFIOffer *)offer;

/**
 * Adds list of offers.
 * @see #getLoyaltyOffers()
 */
- (void)addLoyaltyOffers:(nonnull NSArray<VFIOffer *> *)offers;

/**
 * Removes an offer from the list if it is present.
 * @see #getLoyaltyOffers()
 */
- (void)removeLoyaltyOffer:(nullable VFIOffer *)offer;

/**
 * Adds a LoyaltyIdentifier. At least one is required when creating a loyalty adjustment.
 * @see #getLoyaltyIdentifiers()
 */
- (void)addLoyaltyIdentifier:(nullable VFILoyaltyIdentifier *)loyaltyIdentifier;

/**
 * Adds list of Loyalty identifiers.
 * @see #getLoyaltyIdentifiers()
 */
- (void)addLoyaltyIdentifiers:(nonnull NSArray<VFILoyaltyIdentifier *> *)loyaltyIdentifiers;

/**
 * Removes an LoyaltyIdentifier from the list if it is present.
 * @see #getLoyaltyIdentifiers()
 */
- (void)removeLoyaltyIdentifier:(nullable VFILoyaltyIdentifier *)loyaltyIdentifier;

@end
