// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_entities.djinni

#import <Foundation/Foundation.h>
@class VFILoyaltyIdentifier;


/**
 * This represents the data that is shared between the terminal and the Android application.
 * Setting the fields is only relevant when sending the data to the terminal, and conversely,
 * getting the fields is only relevant when receiving this object from the terminal.
 */
@interface VFILoyaltyIdentifier : NSObject

/** Create LoyaltyIdentifier */
+ (nullable VFILoyaltyIdentifier *)create;

/** Unique reference to identify the Loyalty Program. */
- (nullable NSString *)getProgramId;

/** Loyalty IDs for this customer in the associated program. At least one is required. */
- (nonnull NSArray<NSString *> *)getCustomerLoyaltyId;

/** Available in NFC phone tap. An alternate to Loyalty Id. This is optional. */
- (nullable NSString *)getCustomerPhoneNumber;

/** The name of the customer. This is optional. */
- (nullable NSString *)getCustomerName;

/** The email address of the customer. This is optional. */
- (nullable NSString *)getCustomerEmail;

/**
 * The number of points available to the customer after the matching offer is applied.
 * This is optional.
 */
- (nullable NSString *)getLoyaltyPointsBalance;

/**
 * Some loyalty providers may only pass through to the POS their encrypted data set. This
 * allows a loyalty provider to include their own proprietary fields to parse on the POS side.
 * This is optional.
 */
- (nullable NSString *)getLoyaltyPayload;

/** Unique to the phone for customer tracking purposes. This is optional. */
- (nullable NSString *)getConsumerId;

/**
 * Set program ID
 * @see #getProgramId()
 */
- (void)setProgramId:(nullable NSString *)programId;

/**
 * Set customer loyalty IDs
 * @see #getCustomerLoyaltyId()
 */
- (void)setCustomerLoyaltyId:(nonnull NSArray<NSString *> *)customerLoyaltyId;

/**
 * Set customer phone number
 * @see #getCustomerPhoneNumber()
 */
- (void)setCustomerPhoneNumber:(nullable NSString *)customerPhoneNumber;

/**
 * Set customer name
 * @see #getCustomerName()
 */
- (void)setCustomerName:(nullable NSString *)customerName;

/**
 * Set customer email
 * @see #getCustomerEmail()
 */
- (void)setCustomerEmail:(nullable NSString *)customerEmail;

/**
 * Set loyalty points balance
 * @see #getLoyaltyPointsBalance()
 */
- (void)setLoyaltyPointsBalance:(nullable NSString *)loyaltyPointsBalance;

/**
 * Set loyalty payload
 * @see #getLoyaltyPayload()
 */
- (void)setLoyaltyPayload:(nullable NSString *)loyaltyPayload;

/**
 * Set consumer ID
 * @see #getConsumerId()
 */
- (void)setConsumerId:(nullable NSString *)consumerId;

@end
