// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_payment.djinni

#import <Foundation/Foundation.h>
@class VFILoyaltyAdjustment;
@class VFILoyaltyReceivedEventResponse;
@class VFIOffer;
@class VFIPayment;
@class VFITransaction;

/** Loyalty received event type */
extern NSString * __nonnull const VFILoyaltyReceivedEventTYPE;

/**
 * When loyalty offers and IDs are added by applications in response to the
 * {@link com.verifone.commerce.triggers.LoyaltyRequest} Trigger, the list is returned in this
 * event. This allows the POS application to keep track of changes and provides the opportunity to
 * filter which offers and loyalty accounts are applied to the final transaction.
 */
@interface VFILoyaltyReceivedEvent : NSObject

/**
 * A user-readable message.
 * This message may not be localized, in which case the type field should be used for
 * determining a localized message.
 */
- (nullable NSString *)getMessage;

/** Get the session ID for the session which triggered this event. */
- (nullable NSString *)getSessionId;

/**
 * The type of status. This will generally be SUCCESS for a status of 0, and contain a
 * different type for other errors. For example, in a refund or void, it is possible to
 * receive type TRANSACTION_NOT_FOUND. This may be used for localizing the specific
 * messages as needed
 */
- (nullable NSString *)getType;

/**
 * Get the status for this particular event. A status of 0 means success,
 * any other status is a failure.
 */
- (int32_t)getStatus;

/**
 * Returns the event ID associated with this event. Useful for matching the event received by
 * the listener to the original status returned when issuing the call, for example, calling
 * {@link com.verifone.commerce.payment.TransactionManager#reprintReceipt(Payment)} returns a
 * CommerceEvent containing an event ID, which will match the event ID received by the
 * CommerceListener when the receipt reprint is complete. 
 */
- (nullable NSString *)getEventId;

/** The ID for loyalty record */
- (nullable NSString *)getLoyaltyId;

/** The invoice ID for the transaction as a reference. */
- (nullable NSString *)getInvoiceId;

/** The transaction associated with this event. */
- (nullable VFITransaction *)getTransaction;

/** Get the list of adjustments that have been added by various other applications. */
- (nonnull NSArray<VFILoyaltyAdjustment *> *)getLoyaltyAdjustments;

/** Gets all of the offers aggregated into one list, making it easier to apply all. */
- (nonnull NSArray<VFIOffer *> *)getLoyaltyOffersList;

/** Get the appropriate payment object that led to this adjustment. */
- (nullable VFIPayment *)getPayment;

/** Generates a LoyaltyReceivedResponse object for return to the service. */
- (nullable VFILoyaltyReceivedEventResponse *)generateLoyaltyReceivedEventResponse;

@end
