// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_payment.djinni

#import <Foundation/Foundation.h>
@class VFICommerceResponse;
@class VFILoyaltyIdentifier;
@class VFILoyaltyReceivedEventResponse;
@class VFIOffer;
@class VFIPayment;
@class VFITransaction;
@class VFITransactionEventResponse;


/**
 * Allows the POS application to edit the loyalty offers and accounts after they were 
 * linked by other applications.
 */
@interface VFILoyaltyReceivedEventResponse : NSObject

/** Return TransactionEventResponse from the provided response */
+ (nullable VFITransactionEventResponse *)asTransactionEventResponse:(nullable VFILoyaltyReceivedEventResponse *)loyaltyReceivedEventResponse;

/** Generate CommerceResponse from the provided response */
+ (nullable VFICommerceResponse *)asCommerceResponse:(nullable VFILoyaltyReceivedEventResponse *)loyaltyReceivedEventResponse;

/** Set the loyalty offers that are accepted and applicable for this transaction. */
- (void)setLoyaltyOffers:(nonnull NSArray<VFIOffer *> *)loyaltyOffers;

/**
 * Sets the offers and performs the calculations to change the appropriate amounts.
 * Please note, this does not change the tax amount, only the total amounts for both the
 * transaction and the current payment.
 */
- (void)applyLoyaltyOffers:(nonnull NSArray<VFIOffer *> *)loyaltyOffers;

/** Returns the offers that will be applied to the cart. */
- (nonnull NSArray<VFIOffer *> *)getLoyaltyOffers;

/**
 * Applies the information from the loyalty identifier to the overall transaction. Only one
 * should be used per transaction.
 */
- (void)selectLoyaltyIdentifier:(nullable VFILoyaltyIdentifier *)loyaltyIdentifier;

/**
 * Returns the payment object that started the amount adjustment process. To update this,
 * either update this object directly or use {@link #updatePayment(Payment)};
 */
- (nullable VFIPayment *)getResponsePayment;

/** Update the payment object with the appropriate amounts and set it here. */
- (void)updatePayment:(nullable VFIPayment *)payment;

/** Returns invoice id from event */
- (nullable NSString *)getInvoiceId;

/** Return Transaction from event */
- (nullable VFITransaction *)getTransaction;

/** Update transaction from response */
- (void)updateTransaction:(nullable VFITransaction *)transaction;

@end
