// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_entities.djinni

#import "VFIDecimal.h"
#import <Foundation/Foundation.h>
@class VFIAmountTotals;
@class VFIMerchandise;
@class VFIModifier;


/**
 * This represents the data that is shared between the terminal and the Android application.
 * Setting the fields is only relevant when sending the data to the terminal, and conversely,
 ** getting the fields is only relevant when receiving this object from the terminal.
 */
@interface VFIMerchandise : NSObject

/** create Merchandise */
+ (nullable VFIMerchandise *)create;

/**
 * The unique ID for this merchandise item as it exists in the basket. If multiple items with
 * the same SKU/UPC are added individually to the basket, this basket item ID will be used to
 * distinguish between them. This will be generated by the service if not provided.
 */
- (nullable NSString *)getBasketItemId;

/**
 * The sequence for this item. This is generally auto-incremented as items are added to the
 * basket. This is generally set by the underlying service, but can be set manually if required.
 */
- (int32_t)getSequence;

/**
 * The display order for this item. This is generally auto-incremented as items are added to
 * the basket, using a gap value to allow insertion between items at a later time.
 */
- (int32_t)getDisplayOrder;

/**
 * The line to display to the customer. This may include standard tab and line break characters
 * if desired for normal text, or this may use HTML formatting. This will be generated by the
 * service if not provided.
 */
- (nullable NSString *)getDisplayLine;

/** A human-readable name. This is optional. */
- (nullable NSString *)getName;

/** A human-readable description. This is optional. */
- (nullable NSString *)getDescription;

/** SKU of the item. This is optional. */
- (nullable NSString *)getSku;

/** EAN / UPC of the item. This is optional. */
- (nullable NSString *)getUpc;

/**
 * The final total amount for this item as a GAAP-standard BigDecimal, including the
 * extendedPrice, tax, and discount. This is required.
 */
- (nullable VFIDecimal *)getAmount;

/**
 * The tax for this merchandise based on total quantity as a GAAP-standard BigDecimal. This
 * is optional.
 */
- (nullable VFIDecimal *)getTax;

/**
 * Set to true if this item was removed from the basket, useful for business analytics.
 * Removed items do not contribute to the total transaction amount, and are not displayed nor
 * on the receipt. This is set by the service.
 */
- (BOOL)getRemoved;

/**
 * The unique ID for this merchandise item as it exists in the basket. If multiple items with
 * the same SKU/UPC are added individually to the basket, this basket item ID will be used to
 * distinguish between them. This will be generated by the service if not provided.
 */
- (void)setBasketItemId:(nullable NSString *)itemId;

/**
 * The sequence for this item. This is generally auto-incremented as items are added to the
 * basket. This is generally set by the underlying service, but can be set manually if required.
 */
- (void)setSequence:(int32_t)sequence;

/**
 * The display order for this item. This is generally auto-incremented as items are added to
 * the basket, using a gap value to allow insertion between items at a later time.
 */
- (void)setDisplayOrder:(int32_t)displayOrder;

/**
 * The line to display to the customer. This may include standard tab and line break characters
 * if desired for normal text, or this may use HTML formatting. This will be generated by the
 * service if not provided.
 */
- (void)setDisplayLine:(nullable NSString *)displayLine;

/** A human-readable name. This is optional. */
- (void)setName:(nullable NSString *)name;

/** A human-readable description. This is optional. */
- (void)setDescription:(nullable NSString *)description;

/** SKU of the item. This is optional. */
- (void)setSku:(nullable NSString *)sku;

/** EAN / UPC of the item. This is optional. */
- (void)setUpc:(nullable NSString *)upc;

/**
 * The final total amount for this item as a GAAP-standard BigDecimal, including the
 * extendedPrice, tax, and discount. This is required.
 */
- (void)setAmount:(nullable VFIDecimal *)amount;

/**
 * The tax for this merchandise based on total quantity as a GAAP-standard BigDecimal. This
 * is optional.
 */
- (void)setTax:(nullable VFIDecimal *)tax;

/**
 * Set to true if this item was removed from the basket, useful for business analytics.
 * Removed items do not contribute to the total transaction amount, and are not displayed nor
 * on the receipt. This is set by the service.
 */
- (void)setRemoved:(BOOL)removed;

/** Returns the amounts for this item in the basket. */
- (nullable VFIAmountTotals *)getAmounts;

/** Set the amounts for this item. */
- (void)setAmounts:(nullable VFIAmountTotals *)amounts;

/** Refer to the {@link #setUnitPrice(BigDecimal unitPrice) setUnitPrice(BigDecimal unitPrice)}. */
- (nullable VFIDecimal *)getUnitPrice;

/** Refer to {@link #setQuantity(BigDecimal quantity) setQuantity(int quantity)}. */
- (nullable VFIDecimal *)getQuantity;

- (nullable NSString *)getUnitOfMeasurement;

/**  Refer to {@link #setExtendedPrice(BigDecimal extendedPrice) setExtendedPrice(BigDecimal extendedPrice)} */
- (nullable VFIDecimal *)getExtendedPrice;

/** Refer to the {@link #setDiscount(BigDecimal discount) setDiscount(BigDecimal discount)}. */
- (nullable VFIDecimal *)getDiscount;

/** Returns the modifiers attached to this merchandise. Returns an empty array if there are none. */
- (nonnull NSArray<VFIModifier *> *)getModifiers;

/** The price per unit as a GAAP-standard BigDecimal. This is required. */
- (void)setUnitPrice:(nullable VFIDecimal *)price;

/** The number of units. Defaults to 1 if not set. */
- (void)setQuantity:(nullable VFIDecimal *)quantity;

/** The unit of Measurement for Quantity value */
- (void)setUnitOfMeasurement:(nullable NSString *)unitOfMeasurement;

/** The product of unitPrice and quantity as a GAAP-standard BigDecimal. This is optional. */
- (void)setExtendedPrice:(nullable VFIDecimal *)price;

/** The discount amount for the total quantity as a GAAP-standard BigDecimal. This is optional. */
- (void)setDiscount:(nullable VFIDecimal *)discount;

/** Attaches a modifier to this item, returning success/failure based on ArrayList add. */
- (BOOL)attachModifier:(nullable VFIModifier *)modifier;

/** Removes a modifier from this item, returning success/failure based on ArrayList remove. */
- (BOOL)removeModifier:(nullable VFIModifier *)modifier;

/** update merchandise */
- (void)update:(nullable VFIMerchandise *)merchandise;

@end
