// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_entities.djinni

#import "VFIDecimal.h"
#import <Foundation/Foundation.h>
@class VFIAmountTotals;
@class VFIModifier;


/** Allows attaching a modifier to an existing merchandise object. */
@interface VFIModifier : NSObject

/** create Modifier */
+ (nullable VFIModifier *)create;

/**
 * The unique ID for this merchandise item as it exists in the basket. If multiple items with
 * the same SKU/UPC are added individually to the basket, this basket item ID will be used to
 * distinguish between them. This will be generated by the service if not provided.
 */
- (nullable NSString *)getBasketItemId;

/**
 * The sequence for this item. This is generally auto-incremented as items are added to the
 * basket. This is generally set by the underlying service, but can be set manually if required.
 */
- (int32_t)getSequence;

/**
 * The display order for this item. This is generally auto-incremented as items are added to
 * the basket, using a gap value to allow insertion between items at a later time.
 */
- (int32_t)getDisplayOrder;

/**
 * The line to display to the customer. This may include standard tab and line break characters
 * if desired for normal text, or this may use HTML formatting. This will be generated by the
 * service if not provided.
 */
- (nullable NSString *)getDisplayLine;

/** A human-readable name. This is optional. */
- (nullable NSString *)getName;

/** A human-readable description. This is optional. */
- (nullable NSString *)getDescription;

/** SKU of the item. This is optional. */
- (nullable NSString *)getSku;

/** EAN / UPC of the item. This is optional. */
- (nullable NSString *)getUpc;

/**
 * The final total amount for this item as a GAAP-standard BigDecimal, including the
 * extendedPrice, tax, and discount. This is required.
 */
- (nullable VFIDecimal *)getAmount;

/**
 * The tax for this merchandise based on total quantity as a GAAP-standard BigDecimal. This
 * is optional.
 */
- (nullable VFIDecimal *)getTax;

/**
 * Set to true if this item was removed from the basket, useful for business analytics.
 * Removed items do not contribute to the total transaction amount, and are not displayed nor
 * on the receipt. This is set by the service.
 */
- (BOOL)getRemoved;

/**
 * The unique ID for this merchandise item as it exists in the basket. If multiple items with
 * the same SKU/UPC are added individually to the basket, this basket item ID will be used to
 * distinguish between them. This will be generated by the service if not provided.
 */
- (void)setBasketItemId:(nullable NSString *)itemId;

/**
 * The sequence for this item. This is generally auto-incremented as items are added to the
 * basket. This is generally set by the underlying service, but can be set manually if required.
 */
- (void)setSequence:(int32_t)sequence;

/**
 * The display order for this item. This is generally auto-incremented as items are added to
 * the basket, using a gap value to allow insertion between items at a later time.
 */
- (void)setDisplayOrder:(int32_t)displayOrder;

/**
 * The line to display to the customer. This may include standard tab and line break characters
 * if desired for normal text, or this may use HTML formatting. This will be generated by the
 * service if not provided.
 */
- (void)setDisplayLine:(nullable NSString *)displayLine;

/** A human-readable name. This is optional. */
- (void)setName:(nullable NSString *)name;

/** A human-readable description. This is optional. */
- (void)setDescription:(nullable NSString *)description;

/** SKU of the item. This is optional. */
- (void)setSku:(nullable NSString *)sku;

/** EAN / UPC of the item. This is optional. */
- (void)setUpc:(nullable NSString *)upc;

/**
 * The final total amount for this item as a GAAP-standard BigDecimal, including the
 * extendedPrice, tax, and discount. This is required.
 */
- (void)setAmount:(nullable VFIDecimal *)amount;

/**
 * The tax for this merchandise based on total quantity as a GAAP-standard BigDecimal. This
 * is optional.
 */
- (void)setTax:(nullable VFIDecimal *)tax;

/**
 * Set to true if this item was removed from the basket, useful for business analytics.
 * Removed items do not contribute to the total transaction amount, and are not displayed nor
 * on the receipt. This is set by the service.
 */
- (void)setRemoved:(BOOL)removed;

/** Returns the amounts for this item in the basket. */
- (nullable VFIAmountTotals *)getAmounts;

/** Set the amounts for this item. */
- (void)setAmounts:(nullable VFIAmountTotals *)amounts;

/** Refer to {@link #setQuantity(Decimal quantity)}. */
- (nullable VFIDecimal *)getQuantity;

/** return The unit of Measurement for Quantity value */
- (nullable NSString *)getUnitOfMeasurement;

/** return basket item id attached */
- (nullable NSString *)getAttachedToBasketItemId;

/** Refer to {@link #setQuantity(Decimal quantity)}. */
- (void)setQuantity:(nullable VFIDecimal *)quantity;

/** The unit of Measurement for Quantity value */
- (void)setUnitOfMeasurement:(nullable NSString *)unitOfMeasurement;

/**
 * Set the basket item ID for the item to which this modifier is attached. If not set,
 * this will be set automatically.
 */
- (void)setAttachedToBasketItemId:(nullable NSString *)attachedToBasketItemId;

@end
