// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_payment.djinni

#import "VFINotificationType.h"
#import <Foundation/Foundation.h>
@class VFITransaction;
@class VFITransactionEventResponse;

/** Notification event type */
extern NSString * __nonnull const VFINotificationEventTYPE;

/** Sent when various notifications are received from the terminal that might be helpful to the cashier. */
@interface VFINotificationEvent : NSObject

/**
 * A user-readable message.
 * This message may not be localized, in which case the type field should be used for
 * determining a localized message.
 */
- (nullable NSString *)getMessage;

/** Get the session ID for the session which triggered this event. */
- (nullable NSString *)getSessionId;

/**
 * The type of status. This will generally be SUCCESS for a status of 0, and contain a
 * different type for other errors. For example, in a refund or void, it is possible to
 * receive type TRANSACTION_NOT_FOUND. This may be used for localizing the specific
 * messages as needed
 */
- (nullable NSString *)getType;

/**
 * Get the status for this particular event. A status of 0 means success,
 * any other status is a failure.
 */
- (int32_t)getStatus;

/**
 * Returns the event ID associated with this event. Useful for matching the event received by
 * the listener to the original status returned when issuing the call, for example, calling
 * {@link com.verifone.commerce.payment.TransactionManager#reprintReceipt(Payment)} returns a
 * CommerceEvent containing an event ID, which will match the event ID received by the
 * CommerceListener when the receipt reprint is complete.
 */
- (nullable NSString *)getEventId;

/** The invoice ID for the transaction as a reference. */
- (nullable NSString *)getInvoiceId;

/** The transaction associated with this event. */
- (nullable VFITransaction *)getTransaction;

/**
 * Generate transaction event response for the current event.
 * @return empty response when a standard transaction event. Child classes may implement
 * appropriate responses as needed.
 */
- (nullable VFITransactionEventResponse *)generateTransactionEventResponse;

/** Get Notification type */
- (VFINotificationType)getNotificationType;

/** Get InternalData - mainly for legacy POS support */
- (nullable NSString *)getInternalData;

@end
