// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_entities.djinni

#import "VFIDecimal.h"
#import "VFIOfferType.h"
#import <Foundation/Foundation.h>
@class VFIAmountTotals;
@class VFIOffer;


/**
 * This represents the data that is shared between the terminal and the Android application. Setting
 * the fields is only relevant when sending the data to the terminal, and conversely, getting the
 * fields is only relevant when receiving this object from the terminal.
 */
@interface VFIOffer : NSObject

/** create Offer */
+ (nullable VFIOffer *)create;

/**
 * The unique ID for this merchandise item as it exists in the basket. If multiple items with
 * the same SKU/UPC are added individually to the basket, this basket item ID will be used to
 * distinguish between them. This will be generated by the service if not provided.
 */
- (nullable NSString *)getBasketItemId;

/**
 * The sequence for this item. This is generally auto-incremented as items are added to the
 * basket. This is generally set by the underlying service, but can be set manually if required.
 */
- (int32_t)getSequence;

/**
 * The display order for this item. This is generally auto-incremented as items are added to
 * the basket, using a gap value to allow insertion between items at a later time.
 */
- (int32_t)getDisplayOrder;

/**
 * The line to display to the customer. This may include standard tab and line break characters
 * if desired for normal text, or this may use HTML formatting. This will be generated by the
 * service if not provided.
 */
- (nullable NSString *)getDisplayLine;

/** A human-readable name. This is optional. */
- (nullable NSString *)getName;

/** A human-readable description. This is optional. */
- (nullable NSString *)getDescription;

/** SKU of the item. This is optional. */
- (nullable NSString *)getSku;

/** EAN / UPC of the item. This is optional. */
- (nullable NSString *)getUpc;

/**
 * The final total amount for this item as a GAAP-standard BigDecimal, including the
 * extendedPrice, tax, and discount. This is required.
 */
- (nullable VFIDecimal *)getAmount;

/**
 * The tax for this merchandise based on total quantity as a GAAP-standard BigDecimal. This
 * is optional.
 */
- (nullable VFIDecimal *)getTax;

/**
 * Set to true if this item was removed from the basket, useful for business analytics.
 * Removed items do not contribute to the total transaction amount, and are not displayed nor
 * on the receipt. This is set by the service.
 */
- (BOOL)getRemoved;

/**
 * The unique ID for this merchandise item as it exists in the basket. If multiple items with
 * the same SKU/UPC are added individually to the basket, this basket item ID will be used to
 * distinguish between them. This will be generated by the service if not provided.
 */
- (void)setBasketItemId:(nullable NSString *)itemId;

/**
 * The sequence for this item. This is generally auto-incremented as items are added to the
 * basket. This is generally set by the underlying service, but can be set manually if required.
 */
- (void)setSequence:(int32_t)sequence;

/**
 * The display order for this item. This is generally auto-incremented as items are added to
 * the basket, using a gap value to allow insertion between items at a later time.
 */
- (void)setDisplayOrder:(int32_t)displayOrder;

/**
 * The line to display to the customer. This may include standard tab and line break characters
 * if desired for normal text, or this may use HTML formatting. This will be generated by the
 * service if not provided.
 */
- (void)setDisplayLine:(nullable NSString *)displayLine;

/** A human-readable name. This is optional. */
- (void)setName:(nullable NSString *)name;

/** A human-readable description. This is optional. */
- (void)setDescription:(nullable NSString *)description;

/** SKU of the item. This is optional. */
- (void)setSku:(nullable NSString *)sku;

/** EAN / UPC of the item. This is optional. */
- (void)setUpc:(nullable NSString *)upc;

/**
 * The final total amount for this item as a GAAP-standard BigDecimal, including the
 * extendedPrice, tax, and discount. This is required.
 */
- (void)setAmount:(nullable VFIDecimal *)amount;

/**
 * The tax for this merchandise based on total quantity as a GAAP-standard BigDecimal. This
 * is optional.
 */
- (void)setTax:(nullable VFIDecimal *)tax;

/**
 * Set to true if this item was removed from the basket, useful for business analytics.
 * Removed items do not contribute to the total transaction amount, and are not displayed nor
 * on the receipt. This is set by the service.
 */
- (void)setRemoved:(BOOL)removed;

/** Returns the amounts for this item in the basket. */
- (nullable VFIAmountTotals *)getAmounts;

/** Set the amounts for this item. */
- (void)setAmounts:(nullable VFIAmountTotals *)amounts;

/**
 * Alphanumeric offer reference. May be multiple offers in the same transaction. Could be a back
 * end loaded offer that the POS will redeem or a manufacturer coupon code. This is required.
 */
- (nullable NSString *)getOfferId;

/** The type of the offer. This is required. */
- (nullable NSNumber *)getOfferType NS_SWIFT_NAME(__getOfferType()) NS_REFINED_FOR_SWIFT;

/** Indicates if the purchase is returnable. This is optional. */
- (BOOL)getOfferRefundable;

/** Indicates if the offer may combined with other combinable offers. This is optional. */
- (BOOL)getOfferCombinable;

/**
 * Percentage discount associated with the offer as a BigInteger(13,2). Either this or
 * offerDiscount is required, setting one will override the other.
 */
- (nullable VFIDecimal *)getOfferPercentDiscount;

/**
 * Discount as a GAAP-standard BigDecimal in the transaction currency. This is represented as
 * negative amount. Either this or offerPercentDiscount is required, setting one will override
 * the other.
 */
- (nullable VFIDecimal *)getOfferDiscount;

/** Unique reference to identify the Loyalty Program. This is required. */
- (nullable NSString *)getProgramId;

/** Field for merchant specific offers. This is optional. */
- (nullable NSString *)getMerchantOfferCode;

/** Represented as SKU or UPC. This is optional. */
- (nullable NSString *)getProductCode;

/** Only applies to special product offers. This is optional. */
- (nullable NSString *)getAssociatedProductCode;

/**
 * E.g., BOGO (Buy One Get One) using productCode and associatedProductCode. BOGOH (Buy One Get
 * One Half Off) using productCode, percentageDiscount and associatedProductCode. This is
 * optional.
 */
- (nullable NSString *)getSpecialProductCode;

/** Reserved for future use. This is ignored. */
- (nullable NSString *)getQrCode;

/**
 * The ID of the basket line if this is applied to a specific item in the basket.
 * This is optional.
 */
- (nullable NSString *)getReferenceBasketLineItemId;

/** Refer to {@link #getOfferId()}. */
- (void)setOfferId:(nullable NSString *)offerId;

/** Refer to {@link #getOfferType()}. */
- (void)setOfferType:(nullable NSNumber *)offerType NS_REFINED_FOR_SWIFT;

/** Refer to {@link #getOfferRefundable()}. */
- (void)setOfferRefundable:(BOOL)offerRefundable;

/** Refer to {@link #getOfferCombinable()}. */
- (void)setOfferCombinable:(BOOL)offerCombinable;

/** Refer to {@link #getOfferPercentDiscount()}. */
- (void)setOfferPercentDiscount:(nullable VFIDecimal *)percentDiscount;

/** Refer to {@link #getOfferDiscount()}. */
- (void)setOfferDiscount:(nullable VFIDecimal *)offerDiscount;

/** Refer to {@link #getProgramId()}. */
- (void)setProgramId:(nullable NSString *)programId;

/** Refer to {@link #getMerchantOfferCode()}. */
- (void)setMerchantOfferCode:(nullable NSString *)offerCode;

/** Refer to {@link #getProductCode()}. */
- (void)setProductCode:(nullable NSString *)productCode;

/** Refer to {@link #getAssociatedProductCode()}. */
- (void)setAssociatedProductCode:(nullable NSString *)productCode;

/** Refer to {@link #getSpecialProductCode()}. */
- (void)setSpecialProductCode:(nullable NSString *)productCode;

/** Refer to {@link #getQrCode()}. */
- (void)setQrCode:(nullable NSString *)qrCode;

/** Refer to {@link #getReferenceBasketLineItemId()}. */
- (void)setReferenceBasketLineItemId:(nullable NSString *)basketLineItemId;

/**
 * Someday, implement to allow in basket updates to make it easier when sending items between
 * the service and back.
 */
- (void)update:(nullable VFIOffer *)offer;

@end
