// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_payment.djinni

#import <Foundation/Foundation.h>
@class VFICommerceResponse;
@class VFIOnlineAuthorizationResponse;
@class VFITransaction;
@class VFITransactionEventResponse;


/** Response for online authorization */
@interface VFIOnlineAuthorizationResponse : NSObject

/** Return TransactionEventResponse from the provided response */
+ (nullable VFITransactionEventResponse *)asTransactionEventResponse:(nullable VFIOnlineAuthorizationResponse *)onlineAuthorizationResponse;

/** Generate CommerceResponse from the provided response */
+ (nullable VFICommerceResponse *)asCommerceResponse:(nullable VFIOnlineAuthorizationResponse *)onlineAuthorizationResponse;

/**
 * Gets the online result.
 * @return whether or not an online dialog was successful
 */
- (BOOL)getOnlineResult;

/**
 * Sets the online result to the requested value
 * @param onlineResult whether or not an online dialog was successful
 */
- (void)setOnlineResult:(BOOL)result;

/**
 * Gets the authorization code (EMV tag 89)
 * @return hex string representing the value generated by the authorization authority for an
 * approved transaction
 */
- (nonnull NSString *)getAuthorizationCode;

/**
 * Sets the authorization code (EMV tag 89) to the requested value
 * @param authorizationCode hex string representing the value generated by the authorization
 * authority for an approved transaction
 */
- (void)setAuthorizationCode:(nonnull NSString *)authorizationCode;

/**
 * Gets the authorization response code (EMV tag 8A)
 * @return hex string representing code that defines the disposition of a message
 */
- (nonnull NSString *)getAuthorizationResponseCode;

/**
 * Sets the authorization response code (EMV tag 8A) to the requested value
 * @param authorizationResponseCode hex string representing code that defines 
 * the disposition of a message
 */
- (void)setAuthorizationResponseCode:(nonnull NSString *)code;

/**
 * Gets the issuer authentication data (EMV tag 91)
 * @return hex string representing data sent to the ICC for online issuer 
 * authentication
 */
- (nonnull NSString *)getIssuerAuthenticationData;

/**
 * Sets the issuer authentication data (EMV tag 91) to the requested value
 * @param issuerAuthenticationData hex string representing data sent to the ICC for online
 * issuer authentication
 */
- (void)setIssuerAuthenticationData:(nonnull NSString *)data;

/** Returns invoice id from event */
- (nullable NSString *)getInvoiceId;

/** Return Transaction from event */
- (nullable VFITransaction *)getTransaction;

/** Update transaction from response */
- (void)updateTransaction:(nullable VFITransaction *)transaction;

@end
