// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_entities.djinni

#import "VFIAccountType.h"
#import "VFIAuthorizationMethod.h"
#import "VFIAuthorizationResult.h"
#import "VFIDecimal.h"
#import "VFIPaymentOperation.h"
#import "VFIPaymentOperationHistory.h"
#import "VFIPaymentType.h"
#import "VFIPresentationMethod.h"
#import "VFIReceiptType.h"
#import "VFIStoredValueAction.h"
#import "VFITokenizationMethod.h"
#import "VFITransactionType.h"
#import <Foundation/Foundation.h>
@class VFIAmountTotals;
@class VFICardInformation;
@class VFIImage;
@class VFIInstallment;
@class VFIMerchantAccount;
@class VFIPayment;
@class VFIReceipt;
@class VFIStoredValueCardInformation;


/** Represents an individual payment within the context of the transaction */
@interface VFIPayment : NSObject

/**
 * Factory method to create a payment instance. Please note that the Amounts
 * and RequestedAmounts instances are also created at this time with empty values.
 */
+ (nullable VFIPayment *)create;

/**
 * The payment id, set by the gateway/processor or the alternate payment type provider.
 * For cash payments, this might be set to the local payment ID.
 */
- (nullable NSString *)getPaymentId;

/**
 * An ID generated and assigned by the POS for managing the payment events.
 * This ID is only relevant to the POS, and is used by the POS' internal
 * tracking. This enables a PaymentCompletedEvent to be matched to a specific
 * payment within the POS' own reporting system.
 */
- (nullable NSString *)getLocalPaymentId;

/**
 * Get the related payment ID of the payment that was refunded or voided. For
 * example, Payment1 is made, and the customer desires a refund. Payment2
 * will be created for the refund, and the payment ID from Payment1 will be
 * set as the reference payment ID of Payment2. For voids, refunds, and other
 * follow-on payments, this is required if the AppSpecificData from the
 * original payment is not provided, otherwise this is optional.
 */
- (nullable NSString *)getReferencePaymentId;

/**
 * Get the related local payment ID of the payment that was refunded or
 * voided. See getReferencePaymentId() for more information on how a
 * reference ID is used, and getLocalPaymentId() for more information on how
 * the local ID is used. This may be empty.
 */
- (nullable NSString *)getReferenceLocalPaymentId;

/**
 * Get the ID of the invoice. This is set when the payment is initiated
 * and may not be changed. This may be empty.
 */
- (nullable NSString *)getInvoice;

/**
 * Get the ID of the venue. This is set when the transaction is initiated
 * and may not be changed. This may be empty.
 */
- (nullable NSString *)getVenue;

/**
 * Get the ID or name of the current device. This is set when the transaction is
 * initiated and may not be changed. This may be empty.
 */
- (nullable NSString *)getLane;

/**
 * Get the ID of the cashier, this should be set when the transaction is
 * initiated and may not be changed. This may be empty.
 */
- (nullable NSString *)getCashierId;

/** The account type used to complete this payment. This may be empty. */
- (nullable NSNumber *)getAccountType NS_SWIFT_NAME(__getAccountType()) NS_REFINED_FOR_SWIFT;

/** The payment type used to complete this payment. This may be empty. */
- (nullable NSNumber *)getPaymentType NS_SWIFT_NAME(__getPaymentType()) NS_REFINED_FOR_SWIFT;

/** The method used to pay. This may be empty. */
- (nullable NSString *)getPaymentMethod;

/** Get the ways by which the payment is authorized. This may be empty. */
- (nullable NSNumber *)getAuthorizationMethod NS_SWIFT_NAME(__getAuthorizationMethod()) NS_REFINED_FOR_SWIFT;

/**
 * Get Result of transaction authorization. This is provided by the payment
 * application or payment service provider. This may be empty.
 */
- (nullable NSNumber *)getAuthResult NS_SWIFT_NAME(__getAuthResult()) NS_REFINED_FOR_SWIFT;

/**
 * Get The payment Authorization Code, it usually provided by the payment processing
 * service or acquirer.This may be added during the transaction, but once set should
 * not be changed.
 */
- (nullable NSString *)getAuthCode;

/**
 * Get authorization code from the host payment if there is a gateway or other host
 * between the terminal and the acquirer.
 */
- (nullable NSString *)getHostAuthCode;

/**
 * Get descriptive text accompanying the authorization code from payment processor.
 * This is usually present when the transaction has failed authorization, providing
 * the reason for the failure. This is optional.
 */
- (nullable NSString *)getAuthResponseText;

/**
 * Gets the requested card presentation methods.  Valid presentation methods include:
 * {@link CardInformation.PresentationMethod# MAG_STRIPE},
 * {@link CardInformation.PresentationMethod# CHIP},
 * {@link CardInformation.PresentationMethod# CTLS_CARD} (note that this will allow
 * any type of CTLS presentation),
 * {@link CardInformation.PresentationMethod# KEYED}
 * This is optional and if no presentation methods are requested, by default all card
 * presentation methods supported by the device hardware will be allowed.
 */
- (nonnull NSArray<NSNumber *> *)getRequestedCardPresentationMethods;

/** Get whether is gift card */
- (BOOL)isStoredValueCard;

/**
 * If the payment involves a card / contactless, this provides the
 * relevant information. This might be empty.
 */
- (nullable VFICardInformation *)getCardInformation;

/** Get stored card information, if the payment involves a gift card. */
- (nullable VFIStoredValueCardInformation *)getStoredValueCardInformation;

/**
 * Stores the information necessary to perform other operations on this payment at a later
 * time, such as completing a pre-auth or refunding a specific payment. If the payment object
 * is stored offline, only this field must be saved and restored to complete later operations.
 * This field is limited to 255 characters, and the value should not be modified.
 */
- (nullable NSString *)getAppSpecificData;

/**
 * Get the amount of the payment was approved for as a GAAP-standard BigDecimal. This is
 * provided set during the authorization process.
 */
- (nullable VFIDecimal *)getPaymentAmount;

/** Get the amount of gratuity or Tip if applicable as a GAAP-standard BigDecimal. This is optional */
- (nullable VFIDecimal *)getGratuityAmount;

/** Get the amount of tax as a GAAP-standard BigDecimal. This is optional */
- (nullable VFIDecimal *)getTaxAmount;

/**
 * Get the amount of cashback  as a GAAP-standard BigDecimal. This is optional.
 * This may also refer to a cash advance amount, based on the payment type.
 */
- (nullable VFIDecimal *)getCashbackAmount;

/** Get the amount of fees  as a GAAP-standard BigDecimal. */
- (nullable VFIDecimal *)getFeesAmount;

/**
 * Get the number of units of alternate currency consumed, in the case of an alternate
 * payment type. This is optional.
 */
- (nullable NSString *)getRedeemedUnits;

/**
 * Get the receipts for the payment after the payment is completed. This is possibly empty or
 * only containg one type depending on the success of the payment and the configuration of the
 * payment application.
 */
- (nonnull NSDictionary<NSNumber *, VFIReceipt *> *)getReceipts;

/**
 * Get the signature image provided by the payment application if the Authorization
 * Method contains Signature. This will be empty for all other Authorization Methods.
 */
- (nullable VFIImage *)getSignature;

/**
 * Get the timestamp of payment completion. This is provided by the application which
 * processes the payment.
 */
- (nullable NSString *)getTimestamp;

/**
 * True if the payment was authorized online with the host, or false if this was
 * authorized offline.
 */
- (BOOL)isOnline;

/** The ID of the acquirer used for the payment. This may be empty. */
- (nullable NSString *)getAcquirerId;

/** The name of the acquirer used for the payment. This may be empty. */
- (nullable NSString *)getAcquirerName;

/** Get Merchant identifier */
- (nullable NSString *)getMerchantId;

/** Get Terminal identifier */
- (nullable NSString *)getTerminalId;

/** Refer to setTotalsGroupId(). */
- (nullable NSString *)getTotalsGroupId;

/**
 * Get the approved amounts in the payment.  Please note that these amounts are
 * independent from the requested amounts.
 */
- (nullable VFIAmountTotals *)getAmounts;

/**
 * Get the requested payment amounts, set when a payment is requested by the POS
 * and independent from the approved amounts.
 */
- (nullable VFIAmountTotals *)getRequestedAmounts;

/**
 * Refer to {@link #setInstallment(Installment)}
 * @return Installment object containing installment related information.
 */
- (nullable VFIInstallment *)getInstallment;

/**
 * Refer to {@link #setMerchantAccount(MerchantAccount)}
 * @return MerchantAccount object containing merchant account related information.
 */
- (nullable VFIMerchantAccount *)getMerchantAccount;

/** Refer to {@link #setTransactionType} */
- (nullable NSNumber *)getTransactionType NS_SWIFT_NAME(__getTransactionType()) NS_REFINED_FOR_SWIFT;

/** Get the reconciliation id, set by the nexo payment response */
- (nullable NSString *)getReconciliationId;

/**
 * Get the allowed payment operations
 * A list of operations that can be performed on this payment.
 * If null (or an empty optional for c++), then the allowed operations are unknown.
 * If an empty list, then there are no further operations allowed.
 */
- (nullable NSArray<NSNumber *> *)getAllowedPaymentOperations;

/** Get the maximum completion amount */
- (nullable VFIDecimal *)getMaximumCompletionAmount;

/**
 * Get history of operations performed on a payment to modify it, including, but not
 * limited to pre-authorizations
 * A list of operations that have been performed on this payment.
 * If null (or an empty optional for c++), then the operations history is unknown.
 * If an empty list, then there is no history.
 */
- (nullable NSArray<VFIPaymentOperationHistory *> *)getOperationsHistory;

/**
 * The currency used for this payment. The format is three contiguous capital letters per
 * ISO 4217 "Codes for representation of currencies and funds".
 */
- (nullable NSString *)getCurrency;

/**
 * Set payment ID, This is set by the gateway/processor in the case of a credit/debit
 * payment, or the alternate payment type provider. For cash payments, this may be
 * set to the local payment ID.
 */
- (void)setPaymentId:(nullable NSString *)paymentId;

/** Deprecated on 2021-02-01. Please use setSaleNote() instead. */
- (nullable NSString *)getAdditionalAcquirerData;

/** Refer to setContextData(). */
- (nullable NSString *)getContextData;

/**
 * End of the validity period for the pre-authorization or deferred payment.
 * The payment can be completed and/or updated until this date.
 * This returns an ISO 8601 date string, e.g., 2020-08-04.
 */
- (nullable NSString *)getExpiryDate;

/**
 * True if this was forced offline, false if it was explicitly forced online,
 * otherwise this is empty.
 */
- (nullable NSNumber *)isForceOffline;

/** An optional Reference/Sales Note */
- (nullable NSString *)getSaleNote;

/** An optional Reference/Customer Note */
- (nullable NSString *)getCustomerNote;

/**
 * Get the related payment timestamp of the payment that was refunded or voided. For
 * example, Payment1 is made, and the customer desires a refund. Payment2
 * will be created for the refund, and the payment timestamp from Payment1 will be
 * set as the reference payment timestamp of Payment2. For voids, refunds, and other
 * follow-on payments, this is required if the AppSpecificData from the
 * original payment is not provided, otherwise this is optional.
 */
- (nullable NSString *)getReferenceTimestamp;

/** See getLocalPaymentId() for information on how this is used. This is optional. */
- (void)setLocalPaymentId:(nullable NSString *)paymentId;

/** The Retrieval Reference Number from the payment/reversal response. This may be empty. */
- (nullable NSString *)getRetrievalReferenceNumber;

/** Get stored value action. This may be empty. */
- (nullable NSNumber *)getStoredValueAction NS_SWIFT_NAME(__getStoredValueAction()) NS_REFINED_FOR_SWIFT;

/** See getReferencePaymentId() for information on how this is used. This is optional. */
- (void)setReferencePaymentId:(nullable NSString *)paymentId;

/** See getReferenceLocalPaymentId() for information on how this is used. This is optional. */
- (void)setReferenceLocalPaymentId:(nullable NSString *)paymentId;

/**
 * Set the ID of the invoice. This is set when the payment is initiated and
 * may not be changed. This may be empty.
 */
- (void)setInvoice:(nullable NSString *)invoice;

/**
 * Set the ID of the venue. This is set when the payment is initiated and
 * may not be changed. This may be empty.
 */
- (void)setVenue:(nullable NSString *)venue;

/**
 * Set the ID or name of the current lane. This is set when the payment is
 * initiated and may not be changed. This may be empty.
 */
- (void)setLane:(nullable NSString *)lane;

/** Set the ID of the cashier that is starting this payment. This is optional. */
- (void)setCashierId:(nullable NSString *)cashierId;

/**
 * Request a specific type of payment. This is required to bypass the payment selection screen
 * when the payment application is handling the payment, otherwise this is optional.
 */
- (void)setRequestedPaymentType:(nullable NSNumber *)paymentType NS_REFINED_FOR_SWIFT;

/** Refer to {@link #setRequestedPaymentType(paymentType)}. */
- (nullable NSNumber *)getRequestedPaymentType NS_SWIFT_NAME(__getRequestedPaymentType()) NS_REFINED_FOR_SWIFT;

/** The account type used to complete this payment. */
- (void)setAccountType:(nullable NSNumber *)accountType NS_REFINED_FOR_SWIFT;

/** The payment type used to complete this payment. */
- (void)setPaymentType:(nullable NSNumber *)paymentType NS_REFINED_FOR_SWIFT;

/**
 * This is required for the application which processes the payment, and is generally not
 * set by the POS.
 */
- (void)setPaymentMethod:(nullable NSString *)paymentMethod;

/** Set the ways by which the payment is authorized. This is optional */
- (void)setAuthorizationMethod:(nullable NSNumber *)authorizationMethod NS_REFINED_FOR_SWIFT;

/**
 * Result of transaction authorization. This is provided by the payment application or
 * payment service provider. This may be empty.
 */
- (void)setAuthResult:(nullable NSNumber *)authorizationResult NS_REFINED_FOR_SWIFT;

/**
 * Set The payment Authorization Code, it usually provided by the payment processing
 * service or acquirer.This may be added during the transaction, but once set should
 * not be changed.
 */
- (void)setAuthCode:(nullable NSString *)authCode;

/** Refer to {@link #getHostAuthCode}. */
- (void)setHostAuthCode:(nullable NSString *)hostAuthCode;

/**
 * Set descriptive text accompanying the authorization code from payment processor.
 * This is usually present when the transaction has failed authorization, providing
 * the reason for the failure. This is optional.
 */
- (void)setAuthResponseText:(nullable NSString *)responseText;

/**
 * Sets the requested card presentation methods.  Valid presentation methods include:
 * {@link CardInformation.PresentationMethod# MAG_STRIPE},
 * {@link CardInformation.PresentationMethod# CHIP},
 * {@link CardInformation.PresentationMethod# CTLS_CARD} (note that this will allow any
 * type of CTLS presentation),
 * {@link CardInformation.PresentationMethod# KEYED}
 * This is optional and if no presentation methods are requested, by default all card
 * presentation methods supported by the device hardware will be allowed.
 * @param requestedCardPresentationMethods The requested card presentation methods
 */
- (void)setRequestedCardPresentationMethods:(nonnull NSArray<NSNumber *> *)presentationMethods;

/**
 * Request a specific type of token. This is required to receive a token when the payment is
 * completed.
 */
- (void)setRequestedTokenizationMethod:(nullable NSNumber *)tokenizationMethod NS_REFINED_FOR_SWIFT;

/** Refer to {@link #setRequestedTokenizationMethod(tokenizationMethod)}. */
- (nullable NSNumber *)getRequestedTokenizationMethod NS_SWIFT_NAME(__getRequestedTokenizationMethod()) NS_REFINED_FOR_SWIFT;

/**
 * Set card information if the card information is known by the POS, such as when
 * a token is being used, otherwise this should be empty.
 */
- (void)setCardInformation:(nullable VFICardInformation *)cardInformation;

/**
 * Set stored card information if the payment involves a gift or other stored value card
 * and the POS already knows the card information to be used for the payment, otherwise
 * this should be empty.
 */
- (void)setStoredValueCardInformation:(nullable VFIStoredValueCardInformation *)cardInformation;

/**
 * Set the data from a previous payment object to perform another operation on that payment
 * or to look up a specific payment when querying transactions.
 */
- (void)setAppSpecificData:(nullable NSString *)data;

/**
 * Set the number of units of alternate currency consumed, in the case of an alternate
 * payment type. This is optional.
 */
- (void)setRedeemedUnits:(nullable NSString *)units;

/**
 * Set the receipt for a payment. This is set by the application which processes the payment,
 * so that the required transaction data can be present on the final receipt, otherwise
 * this is not used. This is automatically added to the return receipts map according to the
 * type of the receipt, which means that setting the receipt with the same type a second time
 * will replace any other receipt with the same type that was already stored.
 */
- (void)setReceipt:(nullable VFIReceipt *)receipt;

/**
 * Set the image of the signature collected from the payee. This is provided by the
 * application which processes the payment.
 */
- (void)setSignature:(nullable VFIImage *)image;

/**
 * Set the timestamp of payment completion. This is provided by the application that
 * performs the authorization with the host.
 */
- (void)setTimestamp:(nullable NSString *)timestamp;

/** Set by the application that performs the authorization with the host. */
- (void)setOnline:(BOOL)online;

/**
 * Set the acquirer identifier to be used for this payment if there are multiple acquirers
 * configured.
 */
- (void)setAcquirerId:(nullable NSString *)acquirerId;

/** Set the acquirer name */
- (void)setAcquirerName:(nullable NSString *)acquirerName;

/**
 * Set the MID for the acquirer. This is generally configured within
 * the payment application, and is not set by the POS.
 */
- (void)setMerchantId:(nullable NSString *)merchantId;

/**
 * Set the TID for the acquirer. This is generally configured within
 * the payment application, and is not set by the POS
 */
- (void)setTerminalId:(nullable NSString *)terminalId;

/**
 * Group this payment to other payments by an arbitrary ID. This is useful for looking up
 * payments later and for creating reports. This must be set before
 * performing the payment.
 */
- (void)setTotalsGroupId:(nullable NSString *)totalsGroupId;

/**
 * Set the amounts for the customer, either to be charged to the customer or cleared from
 * the customer, depending on the transaction type. This is required.
 */
- (void)setRequestedAmounts:(nullable VFIAmountTotals *)amountTotals;

/**
 * Set the payment/transaction to an installment type and sets the installment information
 * Refer to {@link Installment}.
 */
- (void)setInstallment:(nullable VFIInstallment *)installment;

/**
 * Set the payment/transaction to an merchant account type and Id information
 * Refer to {@link MerchantAccount}.
 */
- (void)setMerchantAccount:(nullable VFIMerchantAccount *)merchantAccount;

/**
 * This provides a mechanism for the POS to set the
 * type of transaction being requested.
 */
- (void)setTransactionType:(nullable NSNumber *)transactionType NS_REFINED_FOR_SWIFT;

/** Deprecated on 2021-02-01. Please use setSaleNote() instead. */
- (void)setAdditionalAcquirerData:(nullable NSString *)acquirerData;

/**
 * An arbitrary string set by the POS to provide context or state information back to itself
 * when the payment is completed. This is optional.
 */
- (void)setContextData:(nullable NSString *)contextData;

/**
 * Set to true to force the current payment to be authorized offline, set to false to force the
 * payment to be performed online, or empty to let the payment application decide. This is only
 * a recommendation, it is possible for the payment application configuration to override this
 * value.
 */
- (void)setForceOffline:(nullable NSNumber *)forceOffline;

/** Set by the application which authorizes the payment with the host. */
- (void)setRetrievalReferenceNumber:(nullable NSString *)retrievalReferenceNumber;

/**
 * An optional string set as an reconciliation id provided by the host, acquirer, or terminal
 * indicating which batch will settle this payment when settlement is performed.
 */
- (void)setReconciliationId:(nullable NSString *)reconciliationId;

/** See getSaleNote() for information on how this is used. This is optional. */
- (void)setSaleNote:(nullable NSString *)saleNote;

/** See getCustomerNote() for information on how this is used. This is optional. */
- (void)setCustomerNote:(nullable NSString *)customerNote;

/** See getReferenceTimestamp() for information on how this is used. This is optional. */
- (void)setReferenceTimestamp:(nullable NSString *)timestamp;

/**
 * This overrides the currency set in the transaction. See {@link #getCurrency()}
 * for more information. This is optional.
 */
- (void)setCurrency:(nullable NSString *)currency;

/** Set stored value action. This is optional. */
- (void)setStoredValueAction:(nullable NSNumber *)storedValueAction NS_REFINED_FOR_SWIFT;

@end
