// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from PaymentSdk.djinni

#import "VFIPsdkDeviceInformation.h"
#import "VFIPsdkLogLevel.h"
#import <Foundation/Foundation.h>
@class VFIAccessibilityManager;
@class VFIPaymentSdkInterface;
@class VFITransactionManager;
@protocol VFICommerceListener2;
@protocol VFIConnectionInterface;
@protocol VFIPlatformContextInterface;


/**
 * The PaymentSdk is the main entry point for the SDK.
 * Connection management is handled by this component.
 */
@interface VFIPaymentSdkInterface : NSObject

+ (nullable VFIPaymentSdkInterface *)create:(nullable id<VFIPlatformContextInterface>)platformContext;

+ (nonnull NSString *)getVersion;

/**
 * Sets the filename (including path) and maximum size (in KiB) for the log.
 * The log will be truncated on reaching maximum size. Can be called before Initialize().
 */
+ (BOOL)configureLogFile:(nonnull NSString *)filename
                    size:(int64_t)size;

/** Sets the log verbosity to desired level */
+ (void)configureLogLevel:(VFIPsdkLogLevel)level;

/**
 * Initializes the SDK, checking that the configuration is correct and the 
 * Engage device is configured and reachable. The listener receives a Status 
 * with type Status.STATUS_INITIALIZED. Expect StatusCode.SetupRequired 
 * to be sent if the device is not configured. Internally, create the platform 
 * context, coordinator, load the configuration, and initialize the various 
 * modules such as transport, payment adapter, and navigator.
 */
- (void)initialize:(nullable id<VFICommerceListener2>)listener;

/**
 * Initializes the SDK using the values read from the file combined with the 
 * values configured by the user and detected by the system. It's important 
 * that the application already has the necessary permissions to read this 
 * file, the SDK will only try to read it directly. The file must be configured 
 * according to the configuration file documentation.
 */
- (void)initializeFromFile:(nullable id<VFICommerceListener2>)listener
                      path:(nonnull NSString *)path;

/** Initializes the SDK using a parameter map passed into the method. */
- (void)initializeFromValues:(nullable id<VFICommerceListener2>)listener
                      config:(nonnull NSDictionary<NSString *, NSString *> *)config;

/**
 * Initializes the SDK using a parameter map passed into the method and using 
 * the provided connection.
 */
- (void)initializeWithConnection:(nullable id<VFICommerceListener2>)listener
                          config:(nonnull NSDictionary<NSString *, NSString *> *)config
                      connection:(nullable id<VFIConnectionInterface>)connection;

/**
 * Displays the current configuration, or launches the setup wizard if setup is
 * required. This is useful both when handling StatusCode.SetupRequired and
 * displaying a general settings screen. This should be overridden by a method
 * that also accepts the appropriate context/controller to display the setup
 * screens, or returns the controller to be pushed onto the stack, this method
 * is only provided to require subclasses to implement the necessary command,
 * and should be hidden or restricted from being called directly.
 */
- (void)displayConfiguration:(nullable id<VFICommerceListener2>)listener;

/**
 * Allows adding new listeners for events.
 * @param listener A listener for events.
 */
- (void)addListener:(nullable id<VFICommerceListener2>)listener;

/**
 * Removes a listener. The last listener cannot be removed through this method,
 * as there must always be a listener until the PSDK is torn down.
 * @param listener A registered listener for the session events.
 */
- (void)removeListener:(nullable id<VFICommerceListener2>)listener;

/**
 * Simply returns the cached information about the device, does not perform 
 * any type of query to the device. 
 */
- (nullable VFIPsdkDeviceInformation *)getDeviceInformation;

/**
 * Teardown the session and all associated connections. Any objects that were 
 * returned from methods like getTransactionManager() will also be torn down 
 * after this call and any remaining references should not be used.
 */
- (void)tearDown;

/**
 * Get AccessibilityManager for this session.
 * Must have called setupSession successfully prior to making this call
 */
- (nullable VFIAccessibilityManager *)getAccessibilityManager;

/**
 * Get TransactionManager for this session
 * Must have called setupSession successfully prior to making this call
 */
- (nullable VFITransactionManager *)getTransactionManager;

/** Sets/Removes this device as the one to use for future connections. */
- (void)UseDevice:(nonnull VFIPsdkDeviceInformation *)device
       saveDevice:(BOOL)saveDevice;

@end
