// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from PsdkDeviceInformation.djinni

#import "VFIMerchant.h"
#import "VFIPaymentDeviceState.h"
#import <Foundation/Foundation.h>

/**
 * User-displayable information about the connected device and the SDK. 
 * Some values may not be available depending on the connection type and the 
 * messages that have been sent up to this point.
 */
@interface VFIPsdkDeviceInformation : NSObject
- (nonnull instancetype)initWithConnectionType:(nonnull NSString *)connectionType
                                       address:(nonnull NSString *)address
                                  serialNumber:(nonnull NSString *)serialNumber
                                         model:(nonnull NSString *)model
                                  hasNavigator:(nullable NSNumber *)hasNavigator
                               paymentProtocol:(nonnull NSString *)paymentProtocol
                                paymentAppName:(nonnull NSString *)paymentAppName
                             paymentAppVersion:(nonnull NSString *)paymentAppVersion
                               logicalDeviceId:(nonnull NSString *)logicalDeviceId
                                         state:(VFIPaymentDeviceState)state
                                   isListening:(BOOL)isListening
                                merchantConfig:(nonnull NSArray<VFIMerchant *> *)merchantConfig;
+ (nonnull instancetype)PsdkDeviceInformationWithConnectionType:(nonnull NSString *)connectionType
                                                        address:(nonnull NSString *)address
                                                   serialNumber:(nonnull NSString *)serialNumber
                                                          model:(nonnull NSString *)model
                                                   hasNavigator:(nullable NSNumber *)hasNavigator
                                                paymentProtocol:(nonnull NSString *)paymentProtocol
                                                 paymentAppName:(nonnull NSString *)paymentAppName
                                              paymentAppVersion:(nonnull NSString *)paymentAppVersion
                                                logicalDeviceId:(nonnull NSString *)logicalDeviceId
                                                          state:(VFIPaymentDeviceState)state
                                                    isListening:(BOOL)isListening
                                                 merchantConfig:(nonnull NSArray<VFIMerchant *> *)merchantConfig;

/** Connection type, e.g., TCP/IP, Bluetooth or USB. */
@property (nonatomic, readonly, nonnull) NSString * connectionType;

/**
 * The address used for the connection, e.g. IP Address for network 
 * connections, MAC address for Bluetooth, or COM port for USB.
 */
@property (nonatomic, readonly, nonnull) NSString * address;

/** The serial number or hardware device ID associated with the device. */
@property (nonatomic, readonly, nonnull) NSString * serialNumber;

/** The model of the device, e.g., M440.  */
@property (nonatomic, readonly, nonnull) NSString * model;

/**
 * Whether or not Navigator is available on the current device. If Navigator 
 * is not available, any related operations will return with the 
 * NAVIGATOR_NOT_AVAILABLE status code.
 */
@property (nonatomic, readonly, nullable) NSNumber * hasNavigator;

/** The Payment Protocol in use for payment operations. */
@property (nonatomic, readonly, nonnull) NSString * paymentProtocol;

/** The name of the payment app, generally specific to the region. */
@property (nonatomic, readonly, nonnull) NSString * paymentAppName;

/**
 * The version of the payment app, generally specific to the region, and may 
 * or may not follow a normal versioning convention.
 */
@property (nonatomic, readonly, nonnull) NSString * paymentAppVersion;

/**
 * The device ID assigned by the terminal management system or some similar 
 * system. Useful for support.
 */
@property (nonatomic, readonly, nonnull) NSString * logicalDeviceId;

/** The current or most recently known state of the payment device */
@property (nonatomic, readonly) VFIPaymentDeviceState state;

/**
 * Set to false if the device connects to us, or true if we connect to it.
 * If this is false, then it is equivalent to setting TransactionManager::DEVICE_LISTEN_KEY to 
 * the ENABLED_VALUE, because if this is false, then the PSDK must listen for the device.
 */
@property (nonatomic, readonly) BOOL isListening;

/** List of Merchants supported by the terminal */
@property (nonatomic, readonly, nonnull) NSArray<VFIMerchant *> * merchantConfig;

@end

/**
 * When this is the value of the DEVICE_LOGICAL_ID_KEY, any successful 
 * connection to a terminal is accepted, regardless of the device's ID.
 */
extern NSString * __nonnull const VFIPsdkDeviceInformationACCEPTANYDEVICEVALUE;
/** The key to store connection type of the saved device. */
extern NSString * __nonnull const VFIPsdkDeviceInformationDEVICECONNECTIONTYPEKEY;
/** The key to store serial number of the saved device. */
extern NSString * __nonnull const VFIPsdkDeviceInformationDEVICESERIALNUMBERKEY;
/** The key to store device model of the saved device. */
extern NSString * __nonnull const VFIPsdkDeviceInformationDEVICEMODELKEY;
/** The key to store if has navigator support of the saved device. */
extern NSString * __nonnull const VFIPsdkDeviceInformationDEVICEHASNAVIGATORKEY;
/** The key to store logical id of the saved device. */
extern NSString * __nonnull const VFIPsdkDeviceInformationDEVICELOGICALIDKEY;
/**
 * The key to store device address of the saved device. Used during 
 * initialization to select a specific device at a specific address.
 */
extern NSString * __nonnull const VFIPsdkDeviceInformationDEVICEADDRESSKEY;
/** The key to store the state of the device */
extern NSString * __nonnull const VFIPsdkDeviceInformationDEVICESTATEKEY;
