// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_entities.djinni

#import "VFIReceiptSection.h"
#import "VFIReceiptType.h"
#import <Foundation/Foundation.h>
@class VFIImage;
@class VFIReceipt;


/**
 * Provided as a part of the Payment object when a payment is received. This object cannot be
 * retrieved at a later time, and should be stored if re-printing may be required.
 */
@interface VFIReceipt : NSObject

/** Factory methord to create Receipt object */
+ (nullable VFIReceipt *)create;

/**
 * Allows additional customization of the receipt at specific compliant sections of the
 * receipt.
 */
- (nullable NSString *)getTextAtSection:(VFIReceiptSection)section;

/**
 * Returns true if the merchant has decided to include their logo, or false otherwise.
 * Defaults to false.
 */
- (BOOL)isLogoIncluded;

/**
 * Returns true if the merchant has decided to include a custom header, or false otherwise.
 * Defaults to false.
 */
- (BOOL)hasCustomHeader;

/**
 * Returns true if the merchant has decided to include the cashier's name, or false otherwise.
 * Defaults to false.
 */
- (BOOL)isCashierNameIncluded;

/**
 * Returns true if the merchant has decided to include a custom mFooter, or false otherwise.
 * Defaults to false.
 */
- (BOOL)hasCustomFooter;

/**
 * Returns true if the merchant has decided to include an online url for the receipt, or false
 * otherwise. Defaults to false.
 */
- (BOOL)isOnlineUrlIncluded;

/**
 * Returns true if the merchant has decided to include the QR Code with the online url,
 * or false otherwise. Defaults to false.
 */
- (BOOL)isQrCodeIncluded;

/** The type of receipt, generally either for the customer or for the merchant. */
- (nullable NSNumber *)getReceiptType NS_SWIFT_NAME(__getReceiptType()) NS_REFINED_FOR_SWIFT;

/**
 * The Business Info section of the receipt, as customized by the merchant in the receipt
 * settings for this venue.
 */
- (nullable NSString *)getBusinessInfo;

/** Return custom greeting message */
- (nullable NSString *)getCustomGreeting;

/** The footer as defined by the merchant in receipt settings. */
- (nullable NSString *)getCustomFooter;

/** Return Cashier name */
- (nullable NSString *)getCashierName;

/**
 * The transaction information, including basket, adjustments, offers, donations, taxes, and
 * totals, as provided by the payment application.
 */
- (nullable NSString *)getTransactionInformation;

/**
 * The payment information, in particular, the EMV fields or other relevant lines
 * necessary for legal compliance, as provided by the payment application.
 */
- (nullable NSString *)getPaymentInformation;

/**
 * The mFooter as modified by other applications in response to the REQUEST_APPEND_RECEIPT
 * API. Returns the online URL in an HTML-formatted string, including a QR code image if
 * entered by the merchant.
 */
- (nullable NSString *)getOnlineUrl;

/** Return the Qr code image */
- (nullable NSString *)getQrCodeImage;

/** The footer as modified by other applications in response to the REQUEST_APPEND_RECEIPT API. */
- (nullable NSString *)getFooter;

/** Returns the original HTML of the receipt as received from the payment application */
- (nullable NSString *)getOriginalHtml;

/** Convenience method to get the original receipt from the payment application as an image. */
- (nullable VFIImage *)getOriginalImage;

/** Returns the final receipt as HTML. */
- (nullable NSString *)getAsHtml;

/** Returns the final receipt as plain text. */
- (nullable NSString *)getAsPlainText;

/** Refer to {@link #getTextAtSection} */
- (BOOL)insertTextAtSection:(nullable NSString *)text
             receiptSection:(VFIReceiptSection)receiptSection;

@end
