// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_payment.djinni

#import "VFIDeliveryMethod.h"
#import <Foundation/Foundation.h>
@class VFITransaction;
@class VFITransactionEventResponse;

/** Receipt delivery method event type. */
extern NSString * __nonnull const VFIReceiptDeliveryMethodEventTYPE;

/**
 * Contains the selected delivery method and, if relevant, the input value when asking the
 * customer to select from a list of receipt delivery options.
 */
@interface VFIReceiptDeliveryMethodEvent : NSObject

/**
 * A user-readable message.
 * This message may not be localized, in which case the type field should be used for
 * determining a localized message.
 */
- (nullable NSString *)getMessage;

/** Get the session ID for the session which triggered this event. */
- (nullable NSString *)getSessionId;

/**
 * The type of status. This will generally be SUCCESS for a status of 0, and contain a
 * different type for other errors. For example, in a refund or void, it is possible to
 * receive type TRANSACTION_NOT_FOUND. This may be used for localizing the specific
 * messages as needed
 */
- (nullable NSString *)getType;

/**
 * Get the status for this particular event. A status of 0 means success,
 * any other status is a failure.
 */
- (int32_t)getStatus;

/**
 * Returns the event ID associated with this event. Useful for matching the event received by
 * the listener to the original status returned when issuing the call, for example, calling
 * {@link com.verifone.commerce.payment.TransactionManager#reprintReceipt(Payment)} returns a
 * CommerceEvent containing an event ID, which will match the event ID received by the
 * CommerceListener when the receipt reprint is complete. 
 */
- (nullable NSString *)getEventId;

/** The invoice ID for the transaction as a reference. */
- (nullable NSString *)getInvoiceId;

/** The transaction associated with this event. */
- (nullable VFITransaction *)getTransaction;

/**
 * Generate transaction event response for the current event.
 * @return empty response when a standard transaction event. Child classes may implement
 * appropriate responses as needed.
 */
- (nullable VFITransactionEventResponse *)generateTransactionEventResponse;

/**
 * Get the delivery method as selected by the customer.
 * Refer to {@link com.verifone.commerce.entities.Receipt Receipt} for more information.
 */
- (VFIDeliveryMethod)getDeliveryMethod;

/** Get the phone number in the case of the SMS delivery method, or null otherwise. */
- (nullable NSString *)getCustomerPhoneNumber;

/** Get the email address in the case of the EMAIL delivery method, or null otherwise */
- (nullable NSString *)getCustomerEmail;

/** Check for delivery method has value of type EMAIL/SMS. */
- (BOOL)hasValueForType;

@end
