// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_payment.djinni

#import <Foundation/Foundation.h>
@class VFIReceipt;
@class VFIReconciliationTotal;
@class VFITransaction;
@class VFITransactionEventResponse;

/** The event type */
extern NSString * __nonnull const VFIReconciliationEventTYPE;
extern NSString * __nonnull const VFIReconciliationEventACTIVETOTALSTYPE;
extern NSString * __nonnull const VFIReconciliationEventGROUPTOTALSTYPE;

/** Sent to the appropriate listener in response to reconciliation requests. */
@interface VFIReconciliationEvent : NSObject

/**
 * A user-readable message.
 * This message may not be localized, in which case the type field should be used for
 * determining a localized message.
 */
- (nullable NSString *)getMessage;

/** Get the session ID for the session which triggered this event. */
- (nullable NSString *)getSessionId;

/**
 * The type of status. This will generally be SUCCESS for a status of 0, and contain a different
 * type for other errors.
 */
- (nullable NSString *)getType;

/** Get the status for this particular event. A status of 0 means success, any other status is a failure. */
- (int32_t)getStatus;

/**
 * Returns the event ID associated with this event. Useful for matching the event received by
 * the listener to the original status returned when issuing the call, for example, calling
 * {@link com.verifone.commerce.payment.TransactionManager#reprintReceipt(Payment)} returns a
 * CommerceEvent containing an event ID, which will match the event ID received by the
 * CommerceListener when the receipt reprint is complete.
 */
- (nullable NSString *)getEventId;

/** The invoice ID for the transaction as a reference. */
- (nullable NSString *)getInvoiceId;

/** The transaction associated with this event. */
- (nullable VFITransaction *)getTransaction;

/** Generate the TransactionEventResponse associated with this transaction. */
- (nullable VFITransactionEventResponse *)generateTransactionEventResponse;

/** The ID for this reconciliation, or null if not relevant. */
- (nullable NSString *)getReconciliationId;

/**
 * The reconciliation totals, useful for generating a Z report when the type is {@link #TYPE},
 * or an X report when the type is {@link #ACTIVE_TOTALS_TYPE}.
 */
- (nullable NSArray<VFIReconciliationTotal *> *)getReconciliationTotals;

/**
 * In some cases, the terminal will generate this report in an easily-printed fashion. Use
 * the {@link Receipt#getAsHtml()} to obtain an HTML document that can be easily printed.
 */
- (nullable VFIReceipt *)getReport;

@end
