// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_payment.djinni

#import "VFIContentType.h"
#import "VFIInputSubcommand.h"
#import "VFIInputType.h"
#import <Foundation/Foundation.h>
@class VFIImage;
@class VFIMenuEntry;
@class VFIRequestParameters;


/** RequestParameters for UserInputEvents */
@interface VFIRequestParameters : NSObject

/** Creates an instance of RequestParameters */
+ (nullable VFIRequestParameters *)create;

/** Refer to {@link UserInputEvent#getInputType()}. */
- (nullable NSNumber *)getInputType NS_SWIFT_NAME(__getInputType()) NS_REFINED_FOR_SWIFT;

/** Configures the input type for the request. Refer to {@link UserInputEvent#getInputType()}. */
- (void)setInputType:(nullable NSNumber *)inputType NS_REFINED_FOR_SWIFT;

/** Refer to {@link UserInputEvent#getInputSubcommand()}. */
- (nullable NSNumber *)getInputSubcommand NS_SWIFT_NAME(__getInputSubcommand()) NS_REFINED_FOR_SWIFT;

/** Configures the input sbcommand for the request. Refer to {@link UserInputEvent#getInputSubcommand()}. */
- (void)setInputSubcommand:(nullable NSNumber *)inputSubcommand NS_REFINED_FOR_SWIFT;

/** Refer to {@link UserInputEvent#getSignature()}. */
- (nullable VFIImage *)getSignature;

- (void)setSignature:(nullable VFIImage *)signature;

/** Refer to {@link UserInputEvent#getDefaultValue()}. */
- (nullable NSString *)getDefaultValue;

/** Configures the default for the request. Refer to {@link UserInputEvent#getDefaultValue()}. */
- (void)setDefaultValue:(nullable NSString *)defaultValue;

/**
 * If the input type is {@link InputType#MENU_OPTIONS}, and the event type is
 * {@link #REQUEST_TYPE}, then this contains the menu options that should be offered to the
 * cashier.
 */
- (nonnull NSArray<VFIMenuEntry *> *)getMenuEntries;

/**
 * Adds a menu entry to the list of entries.
 * Refer to {@link #getMenuEntries()} for more information.
 */
- (void)addMenuEntry:(nullable VFIMenuEntry *)menuEntry;

/**
 * Sets all of the menu entries at once.
 * Refer to {@link #getMenuEntries()} for more information.
 */
- (void)setMenuEntries:(nonnull NSArray<VFIMenuEntry *> *)menuEntries;

/**
 * Returns the content type, either {@link ContentType#HTML} or
 * {@link ContentType#TEXT}.
 */
- (VFIContentType)getContentType;

/**
 * Sets the content type, either {@link ContentType#HTML} or
 * {@link ContentType#TEXT}.
 */
- (void)setContentType:(VFIContentType)contentType;

/**
 * Sets the content that should be displayed to the cashier according to the type. If
 * the type is {@link InputType#MENU_OPTIONS}, then this should be
 * displayed as a header above the menu options.
 */
- (void)setContent:(nullable NSString *)content;

/**
 * Returns the content that should be displayed to the cashier according to the type. If
 * the type is {@link InputType#MENU_OPTIONS}, then this should be
 * displayed as a header above the menu options.
 */
- (nullable NSString *)getContent;

/**
 * Returns true if this event requires a response, otherwise this is false and everything
 * will continue without a response.
 */
- (BOOL)isResponseRequired;

/** Refer to {@link #isResponseRequired()}. */
- (void)setResponseRequired:(BOOL)responseRequired;

/** Time limit in seconds to send the response, or 0 if unlimited. */
- (nullable NSNumber *)getMaximumInputTime;

/** Sets the Time limit in seconds to send the response. */
- (void)setMaximumInputTime:(nullable NSNumber *)maximumInputTime;

/**
 * Returns true if setShouldRespondImmediately is set for an UserInputEvent.
 * {@link setShouldRespondImmediately}
 */
- (BOOL)shouldRespondImmediately;

/** Sets shouldRespondImmediately for UserInputEvent. */
- (void)setShouldRespondImmediately:(BOOL)shouldRespondImmediately;

/**
 * Minimum length of an entered string, or minimum number of entries that can be selected
 * in a menu. Null if not specified. Lower or equal to MaxLength. InputCommand must be
 * {@link InputType#TEXT}, {@link InputType#NUMBER},
 * {@link InputType#DECIMAL},
 * {@link InputType#PASSWORD} or
 * {@link InputType#MENU_OPTIONS}.
 */
- (nullable NSNumber *)getMinimumLength;

/**
 * Sets the Minimum length of an entered string, or minimum number of entries that can be
 * selected in a menu. Refer to {@link #getMinimumLength()}.
 */
- (void)setMinimumLength:(nullable NSNumber *)minimumLength;

/**
 * Maximum input length of the decimal part (without decimal point). Null if not specified.
 * Greater than MinLength, lower than MaxLength. Not allowed if InputCommand is not
 * {@link InputType#DECIMAL}.
 */
- (nullable NSNumber *)getMaximumLength;

/**
 * Sets the Maximum length of an entered string, or maximum number of entries that can be
 * selected in a menu.# Refer to {@link #getMaximumLength()}.
 */
- (void)setMaximumLength:(nullable NSNumber *)maximumLength;

/**
 * Maximum length of an entered string, or maximum number of entries that can be selected
 * in a menu. Null if not specified. Greater or equal to MinLength. InputCommand must be
 * {@link InputType#TEXT}, {@link InputType#NUMBER},
 * {@link InputType#DECIMAL},
 * {@link InputType#PASSWORD} or
 * {@link InputType#MENU_OPTIONS}.
 */
- (nullable NSNumber *)getMaximumDecimalLength;

/** Refer to {@link #getMaximumDecimalLength()}. */
- (void)setMaximumDecimalLength:(nullable NSNumber *)maximumDecimalLength;

/**
 * Indicates that the user must confirm the entered characters when the maximum allowed
 * length is reached. InputCommand must be {@link InputType#TEXT},
 * {@link InputType#NUMBER} or
 * {@link InputType#DECIMAL} with {@link #setMaximumLength(Integer)} or
 * {@link #setMaximumDecimalLength(Integer)}. Default False.
 */
- (BOOL)shouldWaitForUserValidation;

/** Refer to {@link #shouldWaitForUserValidation()}. */
- (void)setShouldWaitForUserValidation:(BOOL)wait;

/**
 * String mask to get information according to a specific format. Supports symbols '\d' for
 * digits 0-9, '\w' for case insensitive letters (e.g. [a-zA-Z]), and '\.' for any
 * printable character. Any other characters should be preserved as-is. Example: Setting
 * the mask to "(\d\d\d) \d\d\d-\d\d\d\d" will collect a US-style phone number, where the
 * user will be prompted to input 9 digits, and the returned value will look like
 * "(626) 555-5555". InputCommand must be {@link InputType#TEXT},
 * {@link InputType#NUMBER},
 * {@link InputType#DECIMAL} or
 * {@link InputType#PASSWORD}.
 */
- (nullable NSString *)getStringMask;

/** Refer to {@link #getStringMask()}. */
- (void)setStringMask:(nullable NSString *)stringMask;

/**
 * Indicates if the entered character has to be displayed from the right to the left of the
 * display field. Useful when entering amounts for a language that normally reads from left
 * to right. Not allowed if InputCommand is not {@link InputType#TEXT},
 * {@link InputType#NUMBER},
 * {@link InputType#DECIMAL} or
 * {@link InputType#PASSWORD}. Default False for locales that read
 * left-to-right, default True when the current locale reads right-to-left.
 */
- (BOOL)isFromRightToLeft;

/** Refer to {@link #isFromRightToLeft()}. */
- (void)setFromRightToLeft:(BOOL)fromRightToLeft;

/**
 * Indicates that the entry should be masked with an '#' or similar character while being
 * entered. InputCommand must be {@link InputType#TEXT},
 * {@link InputType#NUMBER} or
 * {@link InputType#PASSWORD}. Default False.
 */
- (BOOL)shouldMaskCharacters;

/** Refer to {@link #shouldMaskCharacters()}. */
- (void)setShouldMaskCharacters:(BOOL)shouldMaskCharacters;

/**
 * Returns a bitmap that is to be displayed below the content to the recipient of the
 * request. Generally used for confirming a customer's signature.
 */
- (nullable VFIImage *)getImage;

/** Refer to {@link #getImage()}. */
- (void)setImage:(nullable VFIImage *)image;

@end
