// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_payment.djinni

#import "VFIDecimal.h"
#import <Foundation/Foundation.h>
@class VFIPayment;
@class VFIStoredValueCardInformation;
@class VFITransaction;
@class VFITransactionEventResponse;

/** A stored value card has been successfully activated. */
extern NSString * __nonnull const VFIStoredValueCardEventSTOREDVALUECARDACTIVATED;
/** A stored value card has been successfully reloaded. */
extern NSString * __nonnull const VFIStoredValueCardEventSTOREDVALUECARDRELOADED;
/** A stored value card has been successfully unloaded. */
extern NSString * __nonnull const VFIStoredValueCardEventSTOREDVALUECARDUNLOADED;
/** A stored value card balance has been successfully retrieved. */
extern NSString * __nonnull const VFIStoredValueCardEventSTOREDVALUECARDBALANCERETRIEVED;
/**
 * Deprecated on 2018-11-01.
 * Please use {@link #STORED_VALUE_CARD_ACTIVATED} with a non-zero status code instead.
 * A stored value card has failed to activate.
 */
extern NSString * __nonnull const VFIStoredValueCardEventSTOREDVALUECARDACTIVATIONFAILED;
/**
 * Deprecated on 2018-11-01.
 * Please use {@link #STORED_VALUE_CARD_RELOADED} with a non-zero status code instead.
 * A stored value card has failed to reload.
 */
extern NSString * __nonnull const VFIStoredValueCardEventSTOREDVALUECARDRELOADFAILED;
/**
 * Deprecated on 2018-11-01.
 * Please use {@link #STORED_VALUE_CARD_UNLOADED} with a non-zero status code instead.
 * A stored value card has failed to unload.
 */
extern NSString * __nonnull const VFIStoredValueCardEventSTOREDVALUECARDUNLOADFAILED;
/**
 * Deprecated on 2018-11-01.
 * Please use {@link #STORED_VALUE_CARD_BALANCE_RETRIEVED} with a non-zero status code instead.
 * A stored value card balance has not been retrieved.
 */
extern NSString * __nonnull const VFIStoredValueCardEventSTOREDVALUECARDBALANCERETRIEVALFAILED;

/** An event fired for all interactions with a stored value card. */
@interface VFIStoredValueCardEvent : NSObject

/**
 * A user-readable message.
 * This message may not be localized, in which case the type field should be used for
 * determining a localized message.
 */
- (nullable NSString *)getMessage;

/** Get the session ID for the session which triggered this event. */
- (nullable NSString *)getSessionId;

/**
 * The type of status. This will generally be SUCCESS for a status of 0, and contain a different
 * type for other errors.
 */
- (nullable NSString *)getType;

/** Get the status for this particular event. A status of 0 means success, any other status is a failure. */
- (int32_t)getStatus;

/**
 * Returns the event ID associated with this event. Useful for matching the event received by
 * the listener to the original status returned when issuing the call, for example, calling
 * {@link com.verifone.commerce.payment.TransactionManager#reprintReceipt(Payment)} returns a
 * CommerceEvent containing an event ID, which will match the event ID received by the
 * CommerceListener when the receipt reprint is complete.
 */
- (nullable NSString *)getEventId;

/** The invoice ID for the transaction as a reference. */
- (nullable NSString *)getInvoiceId;

/** The transaction associated with this event. */
- (nullable VFITransaction *)getTransaction;

/** Generate the TransactionEventResponse associated with this transaction. */
- (nullable VFITransactionEventResponse *)generateTransactionEventResponse;

/**
 * Returns the payment object associated with this StoredValueCardEvent
 * {@link StoredValueCardInformation}.
 */
- (nullable VFIPayment *)getPayment;

/** A convenient method to retrieve the {@link StoredValueCardInformation} from the Payment. */
- (nullable VFIStoredValueCardInformation *)getStoredValueCardInformation;

/** A convenient method to retrieve the available balance from the card information, if available. */
- (nullable VFIDecimal *)getAvailableBalance;

/** A convenient method to retrieve the amount due back to the customer. */
- (nullable VFIDecimal *)getCashbackAmount;

@end
