// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_entities.djinni

#import "VFIAccountType.h"
#import "VFICardType.h"
#import "VFIDecimal.h"
#import "VFIEbtType.h"
#import "VFIPresentationMethod.h"
#import "VFITokenizationMethod.h"
#import <Foundation/Foundation.h>
@class VFIStoredValueCardInformation;


/**
 * Represents the card information for use with gift cards or other stored value card types. This
 * can also be used when performing actions for Stored Value. Creating this object and setting
 * the appropriate values will then transmit those values to the payment terminal, potentially
 * simplifying the process on the terminal.
 */
@interface VFIStoredValueCardInformation : NSObject

/** factory methord to create a StoredValueCardInformation instance */
+ (nullable VFIStoredValueCardInformation *)create;

/** Refer to {@link #setBarcode(String)}. */
- (nullable NSString *)getBarcode;

/** Returns the type of card. */
- (nullable NSNumber *)getCardType NS_SWIFT_NAME(__getCardType()) NS_REFINED_FOR_SWIFT;

/** Deprecated. Please use {@link #getAccountType()} instead. */
- (nullable NSNumber *)getEbtType NS_SWIFT_NAME(__getEbtType()) NS_REFINED_FOR_SWIFT;

/** Refer to {@link #setPinCode(String)}. */
- (nullable NSString *)getPinCode;

/** Returns the name of the stored value provider, if available. */
- (nullable NSString *)getProvider;

/**
 * When performing an action for stored value, use this field to set the
 * barcode when it is collected by the POS.
 */
- (void)setBarcode:(nullable NSString *)barcode;

/** Set the type of card. */
- (void)setCardType:(nullable NSNumber *)cardType NS_REFINED_FOR_SWIFT;

/** Deprecated. Please use {@link #setAccountType(AccountType)} instead. */
- (void)setEbtType:(nullable NSNumber *)ebtType NS_REFINED_FOR_SWIFT;

/**
 * When performing an action for stored value, use this field to set the pin
 * code when the information is collected in the POS.
 */
- (void)setPinCode:(nullable NSString *)pinCode;

/** Set the name of the stored value provider. */
- (void)setProvider:(nullable NSString *)provider;

/**
 * Reference of the PAN, which identifies the PAN or the card uniquely, named
 * also PAR (Payment Account Reference). This reference may be defined by the
 * card issuer or by a token service provider under the control of the card
 * issuer, and cannot be used for a payment transaction.
 */
- (nullable NSString *)getAccountReference;

/** The account type used to complete this payment. This may be empty. */
- (nullable NSNumber *)getAccountType NS_SWIFT_NAME(__getAccountType()) NS_REFINED_FOR_SWIFT;

/** The balance remaining on the card. */
- (nullable VFIDecimal *)getAvailableBalance;

/**
 * Depending on the host, sometimes specific user data is provided to
 * supplement the token.
 */
- (nullable NSString *)getBankUserData;

/** The first six digits of the card holder PAN. This might not be provided. */
- (nullable NSString *)getBin;

/** Present only with EMV cards and is representation of EMV Tag5F28. */
- (nullable NSString *)getCardCountry;

/** Present only with EMV cards and is representation of EMV Tag9F42. */
- (nullable NSString *)getCardCurrency;

/** The card expiry when specifically requested. */
- (nullable NSString *)getCardExpiry;

/** This is included only when specifically requested. */
- (nullable NSString *)getCardHolderName;

/**
 * Returns the masked PAN when the card status is PCI_CARD or the clear PAN
 * if the card status is NON_PCI_CARD.
 */
- (nullable NSString *)getCardPan;

/** Present only with EMV cards and is representation of EMV Tag5F2D. */
- (nullable NSString *)getCardPreferredLanguages;

/** The status of the card when the card data is requested specifically. */
- (nullable NSString *)getCardStatus;

/** The token representation of the card. */
- (nullable NSString *)getCardToken;

/** The method by which the card was tokenized. */
- (nullable NSNumber *)getCardTokenizationMethod NS_SWIFT_NAME(__getCardTokenizationMethod()) NS_REFINED_FOR_SWIFT;

/**
 * Card track1. This value is only populated when the payment terminal is
 * explicitly configured to pass back this information.
 */
- (nullable NSString *)getCardTrack1;

/**
 * Card track2. This value is only populated when the payment terminal is
 * explicitly configured to pass back this information.
 */
- (nullable NSString *)getCardTrack2;

/**
 * Card track3. This value is only populated when the payment terminal is
 * explicitly configured to pass back this information.
 */
- (nullable NSString *)getCardTrack3;

/** Refer to {@link #setCvv2(String)}. */
- (nullable NSString *)getCvv2;

/**
 * Present only with EMV cards, this is the relevant EMV Tags necessary for
 * record keeping. The key is the tag, e.g. "9F26", and the value is a string
 * encoding of the EMV value.
 */
- (nonnull NSDictionary<NSString *, NSString *> *)getEmvTags;

/** This is included only when specifically requested. */
- (nullable NSString *)getEncryptedPan;

/** This is included only when specifically requested. */
- (nullable NSString *)getEncryptedPanKsn;

/** This is included only when specifically requested. */
- (nullable NSString *)getEncryptedTracks;

/** This is included only when specifically requested. */
- (nullable NSString *)getEncryptedTracksKsn;

/**
 * Returns an ID for this issuer, as assigned by the host or payment
 * application. Generally null, since it's normally enough to refer to the
 * payment brand.
 */
- (nullable NSString *)getIssuerId;

/** The first two digits of the card holder PAN. This might not be provided. */
- (nullable NSString *)getPanFirst2;

/**
 * A reference returned by the Payment Application to refer to the PAN in
 * question. A Commerce Application may choose to use PAN_Handle to request
 * an encrypted PAN via API CP_APP_REQUESTS_ENCRYPTED_CARD.
 */
- (nullable NSString *)getPanHandle;

/** The last four digits of the card holder PAN. This might not be provided. */
- (nullable NSString *)getPanLast4;

/**
 * The brand for the card. Returns a constant value, see {@link #VISA} as an
 * example, or the literal string received from the terminal if the constant
 * is unrecognized.
 */
- (nullable NSString *)getPaymentBrand;

/** The method used to obtain the card data */
- (nullable NSNumber *)getPresentationMethod NS_SWIFT_NAME(__getPresentationMethod()) NS_REFINED_FOR_SWIFT;

/** Returns base64-encoded VAS string */
- (nullable NSString *)getVasData;

/**
 * Reference of the PAN,  which identifies the PAN or the card uniquely,
 * named also PAR (Payment Account Reference). This reference may be defined
 * by the card issuer or by a token service provider under the control of the
 * card issuer, and cannot be used for a payment transaction.
 */
- (void)setAccountReference:(nullable NSString *)accountReference;

/** The account type used to complete this payment. */
- (void)setAccountType:(nullable NSNumber *)accountType NS_REFINED_FOR_SWIFT;

/** The balance remaining on the card. */
- (void)setAvailableBalance:(nullable VFIDecimal *)availableBalance;

/** Set the bank user data for the token. */
- (void)setBankUserData:(nullable NSString *)bankUserData;

/** Set the first six digits of the PAN. */
- (void)setBin:(nullable NSString *)bin;

/**
 * Set the card country. Set only with EMV cards and is representation of EMV
 * Tag5F28.
 */
- (void)setCardCountry:(nullable NSString *)cardCountry;

/**
 * Set the card currency. Set only with EMV cards and is representation of
 * EMV Tag9F42.
 */
- (void)setCardCurrency:(nullable NSString *)cardCurrency;

/** The card expiry when specifically requested. */
- (void)setCardExpiry:(nullable NSString *)cardExpiry;

/** This is included only when specifically requested. */
- (void)setCardHolderName:(nullable NSString *)cardHolderName;

/**
 * Sets the masked PAN when the card status is PCI_CARD or the clear PAN if
 * the card status is NON_PCI_CARD.
 */
- (void)setCardPan:(nullable NSString *)cardPan;

/**
 * Set the card preferred languages. Set only with EMV cards and is
 * representation of EMV Tag5F2D.
 */
- (void)setCardPreferredLanguages:(nullable NSString *)languages;

/** The status of the card when the card data is requested specifically. */
- (void)setCardStatus:(nullable NSString *)cardStatus;

/**
 * Set the token representation of the payment method. This is required if
 * starting a payment that should use an existing token, otherwise this
 * should not be set.
 */
- (void)setCardToken:(nullable NSString *)cardToken;

/**
 * Set the card tokenization method that was used for the current token. To
 * request a specific tokenization method, please use
 * {@link com.verifone.payment_sdk.Payment#setRequestedTokenizationMethod}.
 */
- (void)setCardTokenizationMethod:(nullable NSNumber *)tokenizationMethod NS_REFINED_FOR_SWIFT;

/**
 * Card track1. This value is only populated when the payment terminal is
 * explicitly configured to pass back this information.
 */
- (void)setCardTrack1:(nullable NSString *)cardTrack1;

/**
 * Card track2. This value is only populated when the payment terminal is
 * explicitly configured to pass back this information.
 */
- (void)setCardTrack2:(nullable NSString *)cardTrack2;

/**
 * Card track3. This value is only populated when the payment terminal is
 * explicitly configured to pass back this information.
 */
- (void)setCardTrack3:(nullable NSString *)cardTrack3;

/**
 * When performing an action for stored value, use this field to set the CVV
 * when it is collected by the POS.
 */
- (void)setCvv2:(nullable NSString *)cvv2;

/** Set the Emv Tags for the current card. */
- (void)setEmvTags:(nonnull NSDictionary<NSString *, NSString *> *)emvTags;

/** This is included only when specifically requested. */
- (void)setEncryptedPan:(nullable NSString *)encryptedPan;

/** This is included only when specifically requested. */
- (void)setEncryptedPanKsn:(nullable NSString *)encryptedPanKsn;

/** This is included only when specifically requested. */
- (void)setEncryptedTracks:(nullable NSString *)encryptedTracks;

/** This is included only when specifically requested. */
- (void)setEncryptedTracksKsn:(nullable NSString *)encryptedTracksKsn;

/** The issuer id of the card */
- (void)setIssuerId:(nullable NSString *)issuerId;

/** Set the first two digits of the PAN. */
- (void)setPanFirst2:(nullable NSString *)panFirst2;

/**
 * A reference set by the Payment Application to refer to a specific PAN,
 * only used while  processing CP Triggers. A Commerce Application may choose
 * to use PAN_Handle to request an  encrypted PAN via API
 * CP_APP_REQUESTS_ENCRYPTED_CARD.
 */
- (void)setPanHandle:(nullable NSString *)panHandle;

/** Set the last four digits of the PAN */
- (void)setPanLast4:(nullable NSString *)panLast4;

/**
 * The brand for the card. A constant value, see {@link #VISA VISA} as an
 * example, or the literal string received from the terminal if the constant
 * is unrecognized.
 */
- (void)setPaymentBrand:(nullable NSString *)paymentBrand;

/** Set the presentation method. The method used to set the card data */
- (void)setPresentationMethod:(nullable NSNumber *)presentationMethod NS_REFINED_FOR_SWIFT;

/** Set base64-encoded VAS string */
- (void)setVasData:(nullable NSString *)vasData;

@end
