// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_entities.djinni

#import "VFIDecimal.h"
#import "VFIKeyedEntryPromptOption.h"
#import "VFIOriginatorType.h"
#import <Foundation/Foundation.h>
@class VFIAmountTotals;
@class VFIBasket;
@class VFIPayment;
@class VFITransaction;


/**
 * Transaction related informations
 * Setting the fields is only relevant when sending the data to the terminal, and conversely,
 * getting the fields is only relevant when receiving this object from the terminal.
 * <p>
 * A word on subtotals. In North America, we automatically calculate the subtotal by subtracting
 * tax and gratuity from the total amount, but leaving donation amounts included.
 */
@interface VFITransaction : NSObject

/** Factory method to create Transaction instance */
+ (nullable VFITransaction *)create;

/** Returns either {@link OriginatorType OriginatorType} */
- (nullable NSNumber *)getOriginator NS_SWIFT_NAME(__getOriginator()) NS_REFINED_FOR_SWIFT;

/** Get the acquirer's merchant ID if available, otherwise returns null. */
- (nullable NSString *)getAcquirerMerchantId;

/** Get the acquirer's terminal ID if available, otherwise returns null */
- (nullable NSString *)getAcquirerTerminalId;

/** Get the ID for the acquirer if available, otherwise returns null. */
- (nullable NSString *)getAcquirerId;

/** Get the gateway's merchant ID if available, otherwise returns null */
- (nullable NSString *)getGatewayMerchantId;

/** Get the gateway's terminal ID if available, otherwise returns null. */
- (nullable NSString *)getGatewayTerminalId;

/**
 * The ID of the invoice. This is generated by the system if not provided, and cannot be
 * changed. The Invoice is an abstract structure containing relevant transactions, a basket,
 * and payments.
 */
- (nullable NSString *)getInvoiceId;

/** Deprecated. Please use {@link #getInvoiceId()} instead. */
- (nullable NSString *)getTransactionId;

/**
 * The ID of a referenced transaction. Generally useful in the case of
 * {@link #VOID_TYPE} or {@link #PRE_AUTHORISATION_COMPLETION_TYPE},
 * referencing the original transaction as the reference transaction for voiding or completing.
 */
- (nullable NSString *)getReferenceTransactionId;

/** The ID of the venue. This is optional. */
- (nullable NSString *)getVenue;

/** The ID of the lane for this device. This is optional. */
- (nullable NSString *)getLane;

/** The ID of the cashier that is starting the current session. This is optional. */
- (nullable NSString *)getCashierId;

/**
 * The display name of the cashier, to be used when printing the receipt or otherwise
 * displaying cashier information. This is optional.
 */
- (nullable NSString *)getCashierDisplayName;

/**
 * The total amount of the transaction to be paid by the customer as a GAAP-standard BigDecimal.
 * This amount may change throughout the transaction depending on basket modifications,
 * discounts, offers, or other interactions by other applications. This is required.
 */
- (nullable VFIDecimal *)getAmount;

/**
 * The total tax amount applied as a GAAP-standard BigDecimal. This amount may change
 * throughout the transaction depending on basket modifications, discounts, offers, or other
 * interactions by other applications. This is optional.
 */
- (nullable VFIDecimal *)getTaxAmount;

/**
 * The total tip/gratuity amount as a GAAP-standard BigDecimal. This amount may change
 * throughout the transaction depending on basket modifications, discounts, offers, or
 * other interactions by other applications. This is optional.
 */
- (nullable VFIDecimal *)getGratuityAmount;

/**
 * The total donation amount as a GAAP-standard BigDecimal. This amount may change throughout
 * the transaction depending on basket modifications, discounts, offers, or other interactions
 * by other applications. This is optional.
 */
- (nullable VFIDecimal *)getDonationAmount;

/** The shift ID provided for this session. */
- (int32_t)getShiftId;

/** Refer to {@link #setCurrency(String currency)} */
- (nullable NSString *)getCurrency;

/** Refer to {@link #setAllowsKeyedEntry(boolean allowsKeyedEntry)} */
- (BOOL)getAllowsKeyedEntry;

/**
 * The language of the customer. This may be added during or after the transaction.
 * This is optional.
 */
- (nullable NSString *)getCustomerLanguage;

/**
 * The phone number of the customer. This may be added during or after the transaction.
 * This is optional.
 */
- (nullable NSString *)getCustomerPhoneNumber;

/**
 * The email address of the customer. This may be added during or after the transaction.
 * This is optional.
 */
- (nullable NSString *)getCustomerEmail;

/**
 * The payments applied to the transaction amount in the order they are initiated. This will
 * update throughout the transaction, as the payment application may handle multiple tenders,
 * or other applications may contribute alternate forms of payment.
 */
- (nonnull NSArray<VFIPayment *> *)getPayments;

/** Refer to {@link #setKeyedPromptOptions(KeyedEntryPromptOption[] promptOptions)} */
- (nonnull NSArray<NSNumber *> *)getKeyedEntryPromptOptions;

/**
 * The basket currently associated with the transaction. The actual object may update over
 * time as it is changed through the AIDL communications with the service and updated by the
 *  Basket Manager, but the contents will stay intact.
 */
- (nullable VFIBasket *)getBasket;

/**
 * A reference transaction. Generally useful in the case of {@link #VOID_TYPE} or
 * {@link #PRE_AUTHORISATION_COMPLETION_TYPE}, include the original
 * transaction as the reference transaction for voiding or completing.
 */
- (nullable VFITransaction *)getReferenceTransaction;

/**
 * Creates a new AmountTotals object based off of the current values. See
 * {@link #setAmountTotals(AmountTotals)}.
 */
- (nullable VFIAmountTotals *)getAmountTotals;

/** Set either {@link #OriginatorType} */
- (void)setOriginator:(nullable NSNumber *)originator NS_REFINED_FOR_SWIFT;

/** Set the acquirer's merchant ID if available */
- (void)setAcquirerMerchantId:(nullable NSString *)merchantId;

/** Set the acquirer's terminal ID if available */
- (void)setAcquirerTerminalId:(nullable NSString *)terminalId;

/** Set the ID for the acquirer if available */
- (void)setAcquirerId:(nullable NSString *)acquirerId;

/** Set the gateway's merchant ID if available */
- (void)setGatewayMerchantId:(nullable NSString *)merchantId;

/** Set the gateway's terminal ID if available */
- (void)setGatewayTerminalId:(nullable NSString *)terminalId;

/**
 * The ID of the invoice. This is generated by the system if not provided, and cannot be
 * changed. The Invoice is an abstract structure containing relevant transactions, a basket,
 * and payments.
 */
- (void)setInvoiceId:(nullable NSString *)invoiceId;

/** Deprecated. Please use {@link #setInvoiceId()} instead. */
- (void)setTransactionId:(nullable NSString *)transactionId;

/**
 * The ID of a referenced transaction. Generally useful in the case of
 * {@link #VOID_TYPE} or {@link #PRE_AUTHORISATION_COMPLETION_TYPE},
 * referencing the original transaction as the reference transaction for voiding or completing.
 */
- (void)setReferenceTransactionId:(nullable NSString *)transactionId;

/** The ID of the venue. This is optional. */
- (void)setVenue:(nullable NSString *)venue;

/** The ID of the lane for this device. This is optional */
- (void)setLane:(nullable NSString *)lane;

/** Refer to getCashierId(). */
- (void)setCashierId:(nullable NSString *)cashierId;

/**
 * The display name of the cashier, to be used when printing the receipt or otherwise
 * displaying cashier information. This is optional.
 */
- (void)setCashierDisplayName:(nullable NSString *)displayName;

/** Set shift id. This is optional. */
- (void)setShiftId:(int32_t)shiftId;

/**
 * The base currency for the transaction. This value should not change after the
 * transaction is started. This is required.
 */
- (void)setCurrency:(nullable NSString *)currency;

/**
 * Determines if the payment application on the terminal will accept keyed
 * entry of card data for payment. Defaults to false. This is required if
 * keyed entry is desired for a specific payment.
 */
- (void)setAllowsKeyedEntry:(BOOL)allowsKeyedEntry;

/**
 * The language of the customer. This may be added during or after the transaction.
 * This is optional.
 */
- (void)setCustomerLanguage:(nullable NSString *)language;

/**
 * The phone number of the customer. This may be added during or after the transaction.
 * This is optional.
 */
- (void)setCustomerPhoneNumber:(nullable NSString *)phoneNumber;

/**
 * The email address of the customer. This may be added during or after the transaction.
 * This is optional.
 */
- (void)setCustomerEmail:(nullable NSString *)email;

/** See getPayments(); */
- (void)setPayments:(nonnull NSArray<VFIPayment *> *)payments;

/**
 * Sets the prompt options desired when keying-in the card information.
 * Meaningful only when allowsKeyedEntry is true.
 */
- (void)setKeyedEntryPromptOptions:(nonnull NSArray<NSNumber *> *)promptOptions;

/** Refer to {@link #getBasket()}. */
- (void)setBasket:(nullable VFIBasket *)basket;

/**  Refer to {@link #getReferenceTransaction()}. */
- (void)setReferenceTransaction:(nullable VFITransaction *)transaction;

/**
 * Allows updating all of the totals at once. If null, resets the amounts back to their
 * default values.
 */
- (void)setAmountTotals:(nullable VFIAmountTotals *)amountTotals;

@end
