// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_payment.djinni

#import <Foundation/Foundation.h>
@class VFITransaction;
@class VFITransactionEventResponse;

/** A general transaction event notifying listeners that something has happened. */
extern NSString * __nonnull const VFITransactionEventTRANSACTIONNOTIFICATION;
/** A general transaction event requesting information from listeners. */
extern NSString * __nonnull const VFITransactionEventTRANSACTIONREQUEST;
/** The event type when a payment has started. */
extern NSString * __nonnull const VFITransactionEventTRANSACTIONPAYMENTSTARTED;
/**
 * The event type when a payment requires online authorization.  An event with this type will
 * only be sent when the client is performing online authorization itself.
 */
extern NSString * __nonnull const VFITransactionEventTRANSACTIONPAYMENTREQUIRESONLINEAUTHORIZATION;
/** The event type when a payment has been completed. */
extern NSString * __nonnull const VFITransactionEventTRANSACTIONPAYMENTCOMPLETED;
/** The event type when an action has started for non-Payment types. */
extern NSString * __nonnull const VFITransactionEventTRANSACTIONSTARTED;
/** The event type when an action has ended for non-Payment types. */
extern NSString * __nonnull const VFITransactionEventTRANSACTIONENDED;
/** A general type when an error has occurred during the transaction. */
extern NSString * __nonnull const VFITransactionEventTRANSACTIONERROR;
/** The transaction has failed. It will need to be started again. */
extern NSString * __nonnull const VFITransactionEventTRANSACTIONFAILED;
/** The login process is complete, check the status for the success/failure of the attempt. */
extern NSString * __nonnull const VFITransactionEventLOGINCOMPLETED;
/** The logout process is complete, check the status for the success/failure of the attempt */
extern NSString * __nonnull const VFITransactionEventLOGOUTCOMPLETED;
/**
 * Sent in response to {@link TransactionManager#reprintReceipt(Payment, int, int, String)}. Only
 * this type and the status will always be provided, since it might not be attached to a session
 * or a transaction.
 */
extern NSString * __nonnull const VFITransactionEventRECEIPTREPRINTED;
/** The event type when receipt is printed. */
extern NSString * __nonnull const VFITransactionEventRECEIPTPRINTED;

/**
 * The listener interface for session events. More than one listener may be registered with a
 * session, but there must always be at least one listener.
 */
@interface VFITransactionEvent : NSObject

/** Return message from event */
- (nullable NSString *)getMessage;

/** Returns the session ID associated with this event, or null if detached from a session. */
- (nullable NSString *)getSessionId;

/**
 * Returns the Transaction Event constants in addition to the {@link CommerceEvent CommerceEvent}
 * and {@link com.verifone.commerce.Status Status} constants. Overridden here only to
 * provide the appropriate documentation.
 */
- (nullable NSString *)getType;

/** Return status */
- (int32_t)getStatus;

/** Returns an optional event ID as copied from the originating event. */
- (nullable NSString *)getEventId;

/** The invoice ID for the transaction. */
- (nullable NSString *)getInvoiceId;

/**
 * The transaction object. Use {@link #updateTransaction(Transaction)} to apply any changes
 * for the transaction, or just update the transaction object returned by this method.
 */
- (nullable VFITransaction *)getTransaction;

/** Return transaction event response */
- (nullable VFITransactionEventResponse *)generateTransactionEventResponse;

@end
