// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_payment.djinni

#import "VFIContentType.h"
#import "VFIDecimal.h"
#import "VFIDeliveryMethod.h"
#import "VFIDeviceManagementAction.h"
#import "VFIDeviceManagementCommand.h"
#import "VFIDisplayType.h"
#import "VFIHostDecisionType.h"
#import "VFIInputType.h"
#import "VFIPresentationMethod.h"
#import "VFIReaderParameters.h"
#import "VFIReceiptType.h"
#import "VFITransactionManagerState.h"
#import <Foundation/Foundation.h>
@class VFIBasketManager;
@class VFICommerceResponse;
@class VFILoginCredentials;
@class VFIPayment;
@class VFIReportManager;
@class VFIStatus;
@class VFIStoredValueCardInformation;
@class VFITransaction;
@class VFIUserInputEventResponse;
@protocol VFICommerceListener;

/**
 * Configures the debug mode of the device. Must be one of
 * {@link com.verifone.commerce.CommerceConstants#MODE_DEVICE},
 * {@link com.verifone.commerce.CommerceConstants#MODE_SIMULATOR},
 * {@link com.verifone.commerce.CommerceConstants#MODE_STUBS_DEBUG},
 * or 0 to remove any preference.
 */
extern NSString * __nonnull const VFITransactionManagerDEBUGMODEKEY;
/**
 * The debug parameters key to set how long the service should 
 * arbitrarily delay the response. This is particularly helpful when testing 
 * in STUB mode for some use cases.
 */
extern NSString * __nonnull const VFITransactionManagerDEBUGDELAYINMSKEY;
/**
 * The debug parameters key to set which types of events should be 
 * arbitrarily returned as failed. This is particularly helpful when testing 
 * in STUB mode for some use cases.
 */
extern NSString * __nonnull const VFITransactionManagerDEBUGFAILEVENTTYPESKEY;
/**
 * The device parameters key to set a login timeout for the device.
 * Please note that this does not apply to SCI terminals. 
 */
extern NSString * __nonnull const VFITransactionManagerDEVICELOGINTIMEOUTKEY;
/**
 * The device parameters key to set which port to use when connecting 
 * to the payment application on the payment terminal. This is useful if 
 * integrating with a payment application that uses a non-standard port for 
 * the messages, and should only be set in specific regions.
 */
extern NSString * __nonnull const VFITransactionManagerDEVICEPORTKEY;
/**
 * The device parameters key to require the POS to listen for connections 
 * from the payment terminal. The default is to connect outwards towards the 
 * terminal. Set this to the #ENABLED_VALUE to enable.
 */
extern NSString * __nonnull const VFITransactionManagerDEVICELISTENKEY;
/**
 * The device parameters key to set training mode for the device. This 
 * should generally be left unset, unless testing in the 
 * simulator or some other environment. Set this to the #ENABLED_VALUE to 
 * enable.
 */
extern NSString * __nonnull const VFITransactionManagerDEVICETRAININGMODEKEY;
/**
 * The device parameters key to set if specifying a specific protocol 
 * to use when communicating with the payment application. This is 
 * generally discovered, though some regions may require this parameter to be 
 * set explicitly.
 */
extern NSString * __nonnull const VFITransactionManagerDEVICEPROTOCOLKEY;
/**
 * The protocol value when communicating using EPAS, supported for 
 * multiple regions.
 */
extern NSString * __nonnull const VFITransactionManagerDEVICEPROTOCOLEPAS;
/**
 * The protocol value when communicating using NEXO, supported for 
 * multiple regions. EPAS changed its name to NEXO when moving to 
 * version 3.0.
 */
extern NSString * __nonnull const VFITransactionManagerDEVICEPROTOCOLNEXO;
/**
 * The protocol value when communicating using the general SCI 
 * protocol, without region-specific modifications.
 */
extern NSString * __nonnull const VFITransactionManagerDEVICEPROTOCOLSCI;
/** The protocol value for Israel. */
extern NSString * __nonnull const VFITransactionManagerDEVICEPROTOCOLIL;
/** The protocol value for the CM5 Payment App when running locally. */
extern NSString * __nonnull const VFITransactionManagerDEVICEPROTOCOLLOCAL;
/** The protocol value for CRS. */
extern NSString * __nonnull const VFITransactionManagerDEVICEPROTOCOLCRS;
/** The protocol value for SDI. */
extern NSString * __nonnull const VFITransactionManagerDEVICEPROTOCOLSDI;
/**
 * Allows the calling POS application to provide an application name, 
 * sometimes used for certification or to meet other requirements.
 */
extern NSString * __nonnull const VFITransactionManagerDEVICEAPPLICATIONNAMEKEY;
/**
 * Allows the calling POS application to provide an application 
 * version, sometimes used for certification or to meet other 
 * requirements.
 */
extern NSString * __nonnull const VFITransactionManagerDEVICEAPPLICATIONVERSIONKEY;
/**
 * Allows the calling POS application to provide a manufacturer ID, 
 * sometimes used for certification or to meet other requirements.
 */
extern NSString * __nonnull const VFITransactionManagerDEVICEAPPLICATIONMANUFACTURERIDKEY;
/**
 * Allows the calling POS application to provide a certification 
 * code, sometimes used for certification or to meet other requirements.
 */
extern NSString * __nonnull const VFITransactionManagerDEVICEAPPLICATIONCERTIFICATIONCODEKEY;
/**
 * Allows the calling POS application to define which CP Triggers 
 * it can support. When passed, this expects an array of the 
 * corresponding event types, e.g., if Amount Adjustment
 * is supported, include the value from 
 * {@link AmountAdjustedEvent#TYPE} in the array. Refer to
 * {@link #enableCpTriggerHandling()} for more information.
 */
extern NSString * __nonnull const VFITransactionManagerDEVICESUPPORTEDCPTRIGGERSKEY;
/**
 * Informs the payment terminal that the POS application should or should not perform the 
 * host authentication. Terminal must be configured for this or initialization will fail.
 */
extern NSString * __nonnull const VFITransactionManagerDEVICEHOSTAUTHENTICATIONKEY;
/** This indicates that the terminal is expected to send authentication request events */
extern NSString * __nonnull const VFITransactionManagerDEVICEHOSTAUTHENTICATIONENABLED;
/**
 * If capable, the terminal can adjust the gratuity amount of a payment which is already
 * captured / completed.
 */
extern NSString * __nonnull const VFITransactionManagerGRATUITYADJUSTMENTCAPABILITY;
/** If capable, the terminal can do delayed charge transactions. */
extern NSString * __nonnull const VFITransactionManagerDELAYEDCHARGECAPABILITY;
/**
 * The value used when enabling a specific key. Generally disabling that 
 * value can be performed by leaving it unset or setting it to an empty value.
 */
extern NSString * __nonnull const VFITransactionManagerENABLEDVALUE;
/** Please use {@link #STATE_LOGGING_IN}. */
extern int32_t const VFITransactionManagerSESSIONSERVICECONNECTING;
/** Please use {@link #STATE_NOT_LOGGED_IN}. */
extern int32_t const VFITransactionManagerSESSIONCLOSED;
/** Please use {@link #STATE_LOGGED_IN}. */
extern int32_t const VFITransactionManagerSESSIONOPEN;
/** Please use {@link #STATE_SESSION_OPEN}. */
extern int32_t const VFITransactionManagerTRANSACTIONPROCESSING;

/**
 * The service handle for performing transactions. Generally, only the 
 * static getTransactionManager methods should be used to obtain an 
 * instance of this class, ensuring
 * that the proper service and binder are wrapped by this class.
 */
@interface VFITransactionManager : NSObject

/**
 * Deprecated on 2020-06-01.
 * Please use {@link #startSession2}.
 */
- (BOOL)startSession:(nullable id<VFICommerceListener>)listener
         transaction:(nullable VFITransaction *)transaction;

/**
 * Starts a session. This reserves the terminal for this application, preventing conflicts
 * with other apps. A listener of CommerceListener2 should be added before calling this API.
 * @param transaction The transaction for this session.  Please note
 * that this parameter may be null if a transaction is not required
 * for the session.
 * @return True if the session opening message was submitted successfully. The SessionListener
 * will receive the start event if the session is created, or will receive the appropriate
 * message if the session is not able to be created.
 */
- (BOOL)startSession2:(nullable VFITransaction *)transaction;

/**
 * Not currently supported. Attempts to resume a session in the case of
 * a Session Closed event or an application crash. If it is not 
 * possible to resume, this may return immediately or
 * may send a Session Resume Failed event to the listener.
 * @param listener The first listener for the session events. There may 
 * be more listeners added, but there must always be at least one 
 * registered. @return True if the session opening message was 
 * submitted successfully. The listener will
 * receive the start event if the session is created, or will receive 
 * the appropriate message if the session is not able to be created.
 * Deprecated on 2020-06-01.
 */
- (BOOL)resumeSession:(nullable id<VFICommerceListener>)listener
            sessionId:(nonnull NSString *)sessionId;

/**
 * Allows adding new listeners for session events.
 * @param listener A listener for session events. There may be more 
 * listeners added, but there must always be at least one registered.
 * @return True if the listener was not already registered.
 * Deprecated on 2020-06-01.
 */
- (BOOL)addSessionListener:(nullable id<VFICommerceListener>)listener;

/**
 * Removes a session listener. The last session listener cannot be 
 * removed through this method, as there must always be a listener 
 * until the session ends. 
 * @param listener A registered listener for the session events. 
 * @return True if the listener exists.
 * Deprecated on 2020-06-01.
 */
- (BOOL)removeSessionListener:(nullable id<VFICommerceListener>)listener;

/**
 * Get the set of currently registered listeners.
 * @return The set of ICommerceListeners that are currently registered. 
 * This set is independent of the internal set, and should only used 
 * as a reference for the current listeners, and
 * not be expected to update with the addition or removal of listeners.
 * Deprecated on 2020-06-01.
 */
- (nonnull NSArray<id<VFICommerceListener>> *)getListeners;

/**
 * Ends a session. This releases the terminal reservation for this 
 * application, allowing other applications to open sessions. This 
 * sends a stop message to the terminal to exit the
 * terminal application if launched by this app. The internal service 
 * may send this on behalf of this POS application if this application 
 * crashes or exits without closing the session. This method should be 
 * called prior to the release of the final reference to the
 * Commerce Manager. Once the session is ended, references to any 
 * registered listeners are removed once the Session End event is 
 * properly reported. 
 * @return True if the session end message was  submitted successfully. 
 * The listener will receive the end event if the session is ended 
 * properly, or will receive the appropriate message if the session is
 * not able to be ended.
 */
- (BOOL)endSession;

/**
 * Gets the most recent transaction. This transaction may still be in 
 * progress, and should be treated accordingly. 
 * @return The most recent transaction.
 */
- (nullable VFITransaction *)getTransaction;

/**
 * The method to get an appropriate concrete implementation of the 
 * Basket Manager. 
 * @return A concrete implementation of the basket manager.
 */
- (nullable VFIBasketManager *)getBasketManager;

/**
 * Starts a payment for the current transaction.
 * @param payment The payment object to use. Use
 * {@link Payment#setRequestedAmounts(AmountTotals)} to set the
 * amount. Use
 * {@link Payment#setAuthorizationMethod(Payment.AuthorizationMethod)}
 * to define the required authorization method.
 */
- (nullable VFIStatus *)startPayment:(nullable VFIPayment *)payment;

/**
 * Attempts to void the transaction.
 * @param payment The payment to void.
 * @return A status object indicating if the void command was issued 
 * properly. Events regarding the void itself are sent to the 
 * registered listener(s).
 */
- (nullable VFIStatus *)processVoid:(nullable VFIPayment *)payment;

/**
 * Attempts to refund the specific payment. If multiple payments were 
 * accepted in a transaction, this method will need to be called 
 * individually for each payment, allowing the listener(s)
 * to better respond to the related events.
 * @param payment  The payment to refund.
 * @return The status object indicating if the refund command was 
 * issued properly. Events regarding the refund itself are sent to the 
 * registered listener(s).
 */
- (nullable VFIStatus *)processRefund:(nullable VFIPayment *)payment;

/**
 * Activates a stored value card. Fires a {@link StoredValueCardEvent} 
 * to the listeners.
 * @param payment A payment object to provide the information needed. 
 * Use {@link Payment#setRequestedAmounts(AmountTotals)} to define
 * the amount to load, optionally use 
 * {@link Payment#setAuthCode(String)} to provide a
 * reference auth code, and optionally use
 * {@link Payment#setCardInformation(CardInformation)} to
 * provide a {@link StoredValueCardInformation} object to provide 
 * further information about the stored value card.
 */
- (nullable VFIStatus *)activateStoredValueCard:(nullable VFIPayment *)payment;

/**
 * Loads an amount on to an existing stored value card. Refer to
 * {@link #activateStoredValueCard(Payment)}.
 */
- (nullable VFIStatus *)loadStoredValueCard:(nullable VFIPayment *)payment;

/**
 * Removes the requested amount from the stored value card. Refer to
 * {@link #activateStoredValueCard(Payment)}.
 * @param payment If this is null or 
 * {@link Payment#getRequestedPaymentAmount()} is not set,
 * The entire available balance will be removed from the card, sometimes
 * requiring a balance inquiry before performing the unload. If
 * {@link Payment#getRequestedPaymentAmount()} is set to an amount, 
 * attempts to remove that amount from the card.
 */
- (nullable VFIStatus *)unloadStoredValueCard:(nullable VFIPayment *)payment;

/**
 * Retrieves the current balance for a stored value card. Fires a
 * {@link StoredValueCardEvent} to the listeners.
 * @param cardInformation Optionally pass card information to use when 
 * fetching the balance.  
 * Use {@link StoredValueCardInformation#setType(String)} to define
 * the type of card for which we are checking the balance. Use
 * {@link StoredValueCardInformation#setCardPan(String)} or
 * {@link StoredValueCardInformation#setCardToken(String)} to pass in
 * the information about the card to be checked.
 */
- (nullable VFIStatus *)getStoredValueCardBalance:(nullable VFIStoredValueCardInformation *)cardInformation;

/**
 * Presents either HTML or Text content to the customer using the customer-facing display. The
 * content will be displayed until some other request is sent to display different content, or
 * something on the device controlling the display decides that it must be updated, depending on
 * the minimum display time.
 * @param content The actual content to be presented.
 * @param contentType The type of content to be presented, either
 *                    {@link ContentType#HTML} or {@link ContentType#TEXT}
 * @param minimumDisplayTime The minimum amount of time to display this content before the
 *                           customer display can update itself to different content. Any
 *                           following request, such as starting a payment or presenting
 *                           additional content, will override the current displayed content
 *                           regardless of this time, but the device controlling the display
 *                           will not update it without a specific command before this time is
 *                           expired. Defaults to 0. Values less than 0 are undefined.
 * @return The status of the request to the terminal. There is no other event returned to the caller.
 */
- (nullable VFIStatus *)presentCustomerContent:(nonnull NSString *)content
                                   contentType:(VFIContentType)contentType
                            minimumDisplayTime:(int32_t)minimumDisplayTime;

/**
 * See {@link #presentCustomerContent} with new parameter displayType.
 * @param displayType please see {@link #DisplayType}.
 */
- (nullable VFIStatus *)presentCustomerContent2:(nonnull NSString *)content
                                    contentType:(VFIContentType)contentType
                             minimumDisplayTime:(int32_t)minimumDisplayTime
                                    displayType:(VFIDisplayType)displayType;

/**
 * Use {@link #presentUserOptions(String header, ArrayList<String> buttonLabels)} 
 * instead.
 */
- (nullable VFIStatus *)presentReceiptDeliveryOptions:(nonnull NSArray<NSNumber *> *)availableDeliveryMethods
                                        customerPhone:(nonnull NSString *)customerPhone
                                        customerEmail:(nonnull NSString *)customerEmail;

/**
 * Presents button options to the user and relaying the 
 * selected option back to the listener. This does not 
 * automatically include a back/exit/cancel option.
 *
 * EPAS reference 4.5.3 Input, 4.5.3.1 Processing Overview. 
 * For #1 Reading Confirmation ("GetAnyKey"), pass a header 
 * with a null or empty array of button labels. For #2 Asks a
 * Question ("GetConfirmation", "SiteManager"), pass two 
 * buttons with the appropriate values. For #4 Select an 
 * item in a Menu ("GetMenuEntry"), pass any number of buttons.
 *
 * SCA reference Customer Buttons. Automatically breaks the 
 * header into the appropriate maximum lengths using word 
 * wrapping. Supports up to 6 header lines followed by 6 
 * buttons.
 *
 * @param header The message to be displayed to the user, 
 * preferably providing context for the user to select the 
 * correct option. This is optional.
 * @param buttonLabels An array of button labels presented 
 * to the user. The corresponding event returns the index of 
 * the button selected based on this array. This is required.
 * @return The status of the request to the payment 
 * terminal. The selected option is returned in the appropriate 
 * {@link UserInputEvent.Values#getSelectedIndices()}.
 */
- (nullable VFIStatus *)presentUserOptions:(nonnull NSString *)header
                              buttonLabels:(nonnull NSArray<NSString *> *)buttonLabels;

/**
 * Presents the user with a screen to collect information, 
 * specially formatting the keyboard and display based on 
 * the input type.
 * @param inputType The type of input requested from the 
 * user. This is required.
 * @param message The message to display to the user to 
 * provide context for the input. This is optional.
 * @param defaultValue The default value for the input 
 * field. This is optional.
 * @return The status of the request to the payment 
 * terminal. The input value is returned in the appropriate 
 * {@link UserInputEvent UserInputEvent}.
 */
- (nullable VFIStatus *)requestUserInput:(VFIInputType)inputType
                                 message:(nonnull NSString *)message
                            defaultValue:(nonnull NSString *)defaultValue;

/**
 * Asks the terminal to collect card information from the user and 
 * return a token for the information. In some regions, this can also 
 * be called after the payment has started to generate a token for the 
 * card that is currently being used for payment, instead of requiring 
 * a separate card entry action.
 * @return The status of the request to the terminal.
 */
- (nullable VFIStatus *)requestCardToken;

/**
 * Allows the service to be set to a different mode, allowing automated 
 * testing and other similar tasks.
 * @param mode One of the debug modes from the CommerceConstants.
 */
- (void)setDebugMode:(int32_t)mode;

/**
 * Adds a listener for events that occur without an active session. For 
 * example, a
 * {@link com.verifone.commerce.payment.reports.ReconciliationEvent} is 
 * sent outside of a session, as the reconciliation commands are not 
 * issued within the context of a session. Returns success if the 
 * listener was added or is already registered, and false if the 
 * listener was not registered.
 * Deprecated on 2020-06-01.
 */
- (BOOL)addGeneralListener:(nullable id<VFICommerceListener>)listener;

/**
 * Removes a listener for events that occur without an active session. 
 * Refer to
 * {@link #addGeneralListener(CommerceListener)} for more information.
 * Returns success if the listener was removed or is not registered, 
 * and false if the listener was not able to be removed.
 * Deprecated on 2020-06-01.
 */
- (BOOL)removeGeneralListener:(nullable id<VFICommerceListener>)listener;

/**
 * The method to get an appropriate concrete implementation of the 
 * Report Manager.
 * @return A concrete implementation of the report manager.
 */
- (nullable VFIReportManager *)getReportManager;

/**
 * Aborts the most recent command, but does not reset the session 
 * unless aborting the startSession call. If a new invoice ID is 
 * needed, or a new cart, end the session or purge the basket, 
 * respectively.
 * @return A status object indicating if the command was issued 
 * properly. Events regarding the effect of the command are sent to the 
 * registered listener(s).
 */
- (nullable VFIStatus *)abort;

/**
 * Checks if the current terminal implementation allows handling of a 
 * specific command, as listed in the constants above. Returns true if 
 * the interface can handle the command, or false if not.
 */
- (BOOL)isCapable:(nonnull NSString *)capability;

/**
 * Logs in through the payment terminal, possibly synchronizing 
 * information from the host to the terminal and performing other 
 * similar setup/configuration steps. Also used for following
 * transactions, allowing them to be tracked by user and/or according 
 * to the shift. Notifies all general listeners with a 
 * {@link TransactionEvent} of type
 * {@link TransactionEvent#LOGIN_COMPLETED}. Use the status from this 
 * event to determine the success or failure of the request, using any 
 * of the constant error codes to determine the nature of the failure 
 * if not successful.
 * @param listener Optional. A commerce listener that is attached to the general events.
 * @param userId Optional. The username / operator ID of the cashier, 
 * used by the payment terminal or the host to group transactions together. 
 * If the host requires login by a specific known cashier/user, then this field is required, 
 * but normally this field is optional and only used for reporting and transaction queries.
 * @param password Optional. Only required when the host must authenticate the current operator,
 *  otherwise this should be unset.
 * @param shiftNumber: Optional. The current shift ID, sometimes used by the payment
 * terminal or the host to group transactions together. This can be used later to query 
 * the transactions performed during this shift.
 * @return A status code. Returns success or failure of sending the request to the terminal. 
 * The actual result will be sent using the notification described 
 * earlier.
 * Deprecated on 2020-06-01.
 * Please use {@link #loginWithCredentials}.
 */
- (nullable VFIStatus *)login:(nullable id<VFICommerceListener>)listener
                       userId:(nullable NSString *)userId
                     password:(nullable NSString *)password
                  shiftNumber:(nullable NSString *)shiftNumber;

/**
 * Logs in through the payment terminal, possibly synchronizing 
 * information from the host to the terminal and performing other 
 * similar setup/configuration steps. Also used for following
 * transactions, allowing them to be tracked by user and/or according 
 * to the shift. Notifies all general listeners with a 
 * {@link TransactionEvent} of type
 * {@link TransactionEvent#LOGIN_COMPLETED}. Use the status from this 
 * event to determine the success or failure of the request, using any 
 * of the constant error codes to determine the nature of the failure 
 * if not successful.
 * @param LoginCredentials.
 * @return A status code. Returns success or failure of sending the request to the terminal. 
 * The actual result will be sent using the notification described 
 * earlier.
 */
- (nullable VFIStatus *)loginWithCredentials:(nullable VFILoginCredentials *)credentials;

/**
 * Logs out through the payment terminal. This must always be used in 
 * conjunction with the
 * {@link #login(CommerceListener, String, String, String)} method. 
 * Returns the success or failure of sending the request to the 
 * terminal. The actual result will be sent to the general
 * listeners with a 
 * {@link TransactionEvent} of type 
 * {@link TransactionEvent#LOGOUT_COMPLETED}.
 * Use the status from this event to determine the success or failure 
 * of the request, using any of the constant error codes to determine 
 * the nature of the failure if not successful.
 */
- (nullable VFIStatus *)logout;

/**
 * Immediately returns the current state of the communication between
 * the POS device and the payment terminal. This may change based 
 * on messages already sent but not yet handled.
 */
- (VFITransactionManagerState)getState;

/**
 * Returns the information requested from the terminal, such as 
 * updating configuration options or performing similar administrative 
 * tasks.
 */
- (nullable VFIStatus *)sendInputResponse:(nullable VFIUserInputEventResponse *)userInputEventResponse;

/**
 * Request information about card data from terminal
 * @param message The message to be displayed in terminal
 * @param inputMethods array of 
 * {@link 
 * com.verifone.commerce.entities.CardInformation.PresentationMethod}, 
 * optional
 * @return The status of the request to the terminal.
 */
- (nullable VFIStatus *)requestCardData:(nonnull NSString *)message
                presentationMethodNames:(nonnull NSArray<NSNumber *> *)presentationMethodNames;

/**
 * Request information about card data from terminal
 * @param message The message to be displayed in terminal
 * @param inputMethods array of
 * {@link
 * com.verifone.commerce.entities.CardInformation.PresentationMethod},
 * @param list of AID(Application ID) strings.
 * @return The status of the request to the terminal.
 */
- (nullable VFIStatus *)requestCardDataWithAids:(nonnull NSString *)message
                        presentationMethodNames:(nonnull NSArray<NSNumber *> *)presentationMethodNames
                                        aidList:(nonnull NSArray<NSString *> *)aidList;

/**
 * Sends back the response to a specific event, allowing the POS to 
 * asynchronously respond to received events.
 */
- (nullable VFIStatus *)sendEventResponse:(nullable VFICommerceResponse *)response;

/**
 * Deprecated on 2020-06-15.
 * Please use {@link PaymentSdk#getDeviceInformation()} instead.
 */
- (nullable VFIStatus *)getDeviceInformation;

/**
 * Convenient method to reprint the customer receipt using
 * {@link com.verifone.commerce.entities.Receipt#DELIVERY_METHOD_PRINT}.
 */
- (nullable VFIStatus *)reprintReceipt:(nullable VFIPayment *)payment
                           receiptType:(VFIReceiptType)receiptType
                 receiptDeliveryMethod:(VFIDeliveryMethod)receiptDeliveryMethod
                       deliveryAddress:(nullable NSString *)deliveryAddress;

/**
 * Sends back the response to a host authorization request.
 * @param authorizationCode The Authorization code sent from the host.
 * @param hostDecision Enum representing the Hosts decision for the request see {@link HostDecisionType}.
 * @param emvTags EMV Tags to be sent to the POI deviceAuthAmount.
 * @param authAmount The amount which has been authorized, including, if applicable, the approved cashback amount. Optional.
 * Note: When this parameter is omitted but the transaction has been authorized, the result will be an partial authorization
 * with a zero amount.
 */
- (nullable VFIStatus *)respondToHostAuthorization:(nonnull NSString *)authorizationCode
                                      hostDecision:(VFIHostDecisionType)hostDecision
                                           emvTags:(nonnull NSDictionary<NSString *, NSString *> *)emvTags
                                        authAmount:(nullable VFIDecimal *)authAmount;

/**
 * Sends back the response to a finalize transaction request
 * @param authorizationCode The Authorization code sent from the host.
 * @param hostDecision Enum representing the Hosts decision for the request see {@link HostDecisionType}.
 * @param emvTags EMV Tags to be sent to the POI deviceAuthAmount.
 * @param authAmount The amount which has been authorized, including, if applicable, the approved cashback amount. Optional.
 * Note: When this parameter is omitted but the transaction has been authorized, the result will be an partial authorization
 * with a zero amount.
 */
- (nullable VFIStatus *)respondToHostFinalizeTransaction:(nonnull NSString *)authorizationCode
                                            hostDecision:(VFIHostDecisionType)hostDecision
                                                 emvTags:(nonnull NSDictionary<NSString *, NSString *> *)emvTags
                                              authAmount:(nullable VFIDecimal *)authAmount;

/** Perform device management action */
- (nullable VFIStatus *)performDeviceManagement:(VFIDeviceManagementAction)deviceManagementAction;

/** Perform device management action with parameters */
- (nullable VFIStatus *)performDeviceManagementCommand:(nonnull VFIDeviceManagementCommand *)deviceManagementCommand;

/**
 * Based on DeliveryMethod settings and terminal capabilities, print the document on the
 * terminal or send through SMS/Email.
 * @param document The document to be printed on the terminal.
 * @param contentType {@link ContentType}.
 * @param receiptType  optional. {@link ReceiptType}.
 * @param receiptDeliveryMethod optional. {@link DeliveryMethod}.
 * @param deliveryAddress optional.
 * @return The status of the print request to the terminal.
 */
- (nullable VFIStatus *)print:(nonnull NSString *)document
                  contentType:(VFIContentType)contentType
                  receiptType:(nullable NSNumber *)receiptType
        receiptDeliveryMethod:(nullable NSNumber *)receiptDeliveryMethod
              deliveryAddress:(nullable NSString *)deliveryAddress NS_REFINED_FOR_SWIFT;

/**
 * Activates the Contact, Contactless, and Mag-stripe readers on the device. The 
 * listener receives a CardInformationReceivedEvent if the customer presents something.
 */
- (void)enableReader:(nonnull VFIReaderParameters *)parameters;

@end
