// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_payment_reports.djinni

#import <Foundation/Foundation.h>
@class VFICardInformation;
@class VFIPayment;
@class VFITransactionQuery;

/** If capable, the fields returned can be filtered to a subset */
extern NSString * __nonnull const VFITransactionQueryTRANSACTIONQUERYFILTERFIELDSCAPABILITY;
/** If capable, the startPaymentId and endPaymentId can be used to query transactions. */
extern NSString * __nonnull const VFITransactionQueryTRANSACTIONQUERYPAYMENTIDBOUNDSCAPABILITY;
/** If capable, the setPaymentIds or setPayments can be used to query transactions. */
extern NSString * __nonnull const VFITransactionQueryTRANSACTIONQUERYBYPAYMENTCAPABILITY;

/**
 * Allows the payment terminal transaction status to be queried. The most recent transaction can
 * always be queried, but the capability checks are extremely important for other types of queries,
 * as the support for these queries will vary between regions and hosts.
 */
@interface VFITransactionQuery : NSObject

/** factory methord to create TransactionQuery instance */
+ (nullable VFITransactionQuery *)create;

/**
 * Search for a CardInformation with the card number. This can be further modified to help search 
 * using various CardInformation properties as well
 */
- (void)setCardInformation:(nullable VFICardInformation *)cardInformation;

/** Optionally set a start time in milliseconds from Epoch. */
- (void)setStartTime:(nullable NSNumber *)startTime;

/** Optionally set an end time in milliseconds from Epoch. */
- (void)setEndTime:(nullable NSNumber *)endTime;

/**
 * Optionally search starting at a specific payment ID. This can work when the payment ID is a
 * value that increments, otherwise the behavior is undetermined. This must not be used with
 * a collection of payment IDs or payments.
 */
- (void)setStartPaymentId:(nullable NSString *)startPaymentId;

/**
 * Optionally search ending at a specific payment ID. This can work when the payment ID is a
 * value that increments, otherwise the behavior is undetermined. This must not be used with
 * a collection of payment IDs or payments.
 */
- (void)setEndPaymentId:(nullable NSString *)endPaymentId;

/**
 * Search for a collection of payment IDs, only returning results that are contained in this
 * collection. This should not be used with a collection of payments or a start/end payment ID.
 */
- (void)setPaymentIds:(nonnull NSArray<NSString *> *)paymentIds;

/**
 * Remove a specific set of payment IDs from the query. Refer to
 * {@link #setPaymentIds(Collection)} for more information.
 */
- (void)removePaymentIds:(nonnull NSArray<NSString *> *)paymentIds;

/**
 * Adds a single payment ID to the list for searching. Refer to
 * {@link #setPaymentIds(Collection)} for more information.
 */
- (void)addPaymentId:(nullable NSString *)paymentId;

/**
 * Removes a single payment ID to the list for searching. Refer to
 * {@link #setPaymentIds(Collection)} for more information.
 */
- (void)removePaymentId:(nullable NSString *)paymentId;

/**
 * Search for a collection of payments, only returning results that directly match the payments
 * provided in this collection. This may only use the payment ID to perform the query, or it may
 * perform more extensive checks and searches, depending on the region and the host. This
 * should not be used with a collection of payment IDs or a start/end payment ID.
 */
- (void)setPayments:(nonnull NSArray<VFIPayment *> *)payments;

/**
 * Remove a specific set of payments from the query. Refer to
 * {@link #setPayments(Collection)} for more information.
 */
- (void)removePayments:(nonnull NSArray<VFIPayment *> *)payments;

/**
 * Add a specific payment to the query. Refer to
 * {@link #setPayments(Collection)} for more information.
 */
- (void)addPayment:(nullable VFIPayment *)payment;

/**
 * Remove a specific payment from the query. Refer to
 * {@link #setPayments(Collection)} for more information.
 */
- (void)removePayment:(nullable VFIPayment *)payment;

/**
 * Allows the results to be filtered to only retrieve a certain subset of fields. This does not
 * guarantee the presence of a specific field, as the query may not be able to provide that
 * field. To add a field for retrieval, use the java.lang.reflect package to get the name of a
 * specific public "getter" field. Example:
 * {@code Transaction.class.getMethod("getInvoiceId").getName()}
 */
- (void)setFieldsToRetrieve:(nonnull NSArray<NSString *> *)fieldsToRetrieve;

/**
 * Limits the query to check on transactions that were processed offline, returning their
 * current status.
 */
- (void)setOffline:(nullable NSNumber *)offline;

/**
 * Limits the query to transactions within a specific shift. The shift must be specified when
 * logging in.
 */
- (void)setShiftId:(nullable NSString *)shiftId;

/**
 * Limits the query to transactions linked to a specific user. The user ID must be specified
 * when logging in, or set on the {@link com.verifone.commerce.entities.Transaction} object for
 * a session.
 */
- (void)setUserId:(nullable NSString *)userId;

/** Limit the query to only return this many results. A limit of <= 0 means no limit. */
- (void)setLimit:(nullable NSNumber *)limit;

/**
 * Request the query to start at offset.
 * Supported at {@link com.verifone.Constants#SDK_PARCEL_VERSION} 14
 */
- (void)setOffset:(nullable NSNumber *)offset;

/**
 * Sets the query to retrieve only the most recent transaction. This transaction may still be
 * in progress, it is best to check the returned values to determine if the transaction is
 * still being processed or is complete.
 */
- (void)setQueryingLastTransaction:(BOOL)isQueryingLastTransaction;

/** Optionally set SaleNote value for transaction to match. */
- (void)setSaleNote:(nullable NSString *)saleNote;

/** Optionally set CustomerNote value for transaction to match. */
- (void)setCustomerNote:(nullable NSString *)customerNote;

/** Optionally set a expiry start time in milliseconds from Epoch. Used in pre-auth transactions. */
- (void)setExpiryStartTime:(nullable NSNumber *)expiryStartTime;

/** Optionally set a expiry end time in milliseconds from Epoch. Used in pre-auth transactions. */
- (void)setExpiryEndTime:(nullable NSNumber *)expiryEndTime;

/**
 * Optionally set a terminal ID to query the transactions linked to a specific terminal.
 * Terminal ID is acquirer terminal ID.
 */
- (void)setTerminalId:(nullable NSString *)terminalId;

/**
 * Optionally set a merchant ID to query the transactions linked to a specific merchant.
 * Merchant ID is acquirer merchant ID.
 */
- (void)setMerchantId:(nullable NSString *)merchantId;

/** Refer to {@link #setCardInformation(Collection)}. */
- (nullable VFICardInformation *)getCardInformation;

/** A unique identifier for this query. */
- (nullable NSString *)getQueryId;

/**
 * Gets the start time in milliseconds from Epoch if it is set.
 * Refer to {@link #setStartTime(long)}.
 */
- (nullable NSNumber *)getStartTime;

/**
 * Gets the end time in milliseconds from Epoch if it is set.
 * Refer to {@link #setEndTime(long)}.
 */
- (nullable NSNumber *)getEndTime;

/** Gets the start PaymentId. Refer to {@link #setStartPaymentId(String)}. */
- (nullable NSString *)getStartPaymentId;

/** Gets the end PaymentId. Refer to {@link #setEndPaymentId(String)}. */
- (nullable NSString *)getEndPaymentId;

/**
 * Returns the collection of payment IDs.
 * Refer to {@link #setPaymentIds(Collection)}.
 */
- (nonnull NSArray<NSString *> *)getPaymentIds;

/** Refer to {@link #setPayments(Collection)}. */
- (nonnull NSArray<VFIPayment *> *)getPayments;

/** Refer to {@link #setFieldsToRetrieve(Collection)}. */
- (nonnull NSArray<NSString *> *)getFieldsToRetrieve;

/** Refer to {@link #setOffline(boolean)}. */
- (nullable NSNumber *)isOffline;

/** Refer to {@link #setShiftId(String)}. */
- (nullable NSString *)getShiftId;

/** Refer to {@link #setUserId(String)}. */
- (nullable NSString *)getUserId;

/** Refer to {@link #setLimit(int)}. */
- (nullable NSNumber *)getLimit;

/** Returns the offset set by setOffset. Refer to {@link #setOffset(int)}. */
- (nullable NSNumber *)getOffset;

/** Returns true if this is simply retrieving the information on the most recent transaction. */
- (BOOL)isQueryingLastTransaction;

/** Refer to {@link #setSaleNote(String)}. */
- (nullable NSString *)getSaleNote;

/** Refer to {@link #setCustomerNote(String)}. */
- (nullable NSString *)getCustomerNote;

/**
 * Gets the expiry start time in milliseconds from Epoch if it is set.
 * Refer to {@link #setExpiryStartTime(long)}.
 */
- (nullable NSNumber *)getExpiryStartTime;

/**
 * Gets the expiry end time in milliseconds from Epoch if it is set.
 * Refer to {@link #setExpiryEndTime(long)}.
 */
- (nullable NSNumber *)getExpiryEndTime;

/** Refer to {@link #setTerminalId(String)}. */
- (nullable NSString *)getTerminalId;

/** Refer to {@link #setMerchantId(String)}. */
- (nullable NSString *)getMerchantId;

@end
