// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_payment.djinni

#import "VFIInputSubcommand.h"
#import "VFIInputType.h"
#import <Foundation/Foundation.h>
@class VFIImage;
@class VFIRequestParameters;
@class VFITransaction;
@class VFIUserInputEventResponse;
@class VFIValues;

/**
 * The type when responding to the
 * {@link TransactionManager#requestUserInput(String, String, String)} or the
 * {@link TransactionManager#presentUserOptions(String, String[])} methods.
 */
extern NSString * __nonnull const VFIUserInputEventRECEIVEDTYPE;
/** The type when the terminal/POI is requesting input from the cashier. */
extern NSString * __nonnull const VFIUserInputEventREQUESTTYPE;
/**
 * @Deprecated
 * Use {@link #RECEIVED_TYPE} instead.
 */
extern NSString * __nonnull const VFIUserInputEventTYPE;
/** Enables querying if the device supports masking the input. */
extern NSString * __nonnull const VFIUserInputEventINPUTMASKCAPABILITY;

/** Either contains the information requested from the customer, or enables sending a response to collect information from the cashier. */
@interface VFIUserInputEvent : NSObject

/**
 * A user-readable message.
 * This message may not be localized, in which case the type field should be used for
 * determining a localized message.
 */
- (nullable NSString *)getMessage;

/** Get the session ID for the session which triggered this event. */
- (nullable NSString *)getSessionId;

/** The event type, either {@link #RECEIVED_TYPE} or {@link #REQUEST_TYPE}. */
- (nullable NSString *)getType;

/** Get the status for this particular event. A status of 0 means success, any other status is a failure. */
- (int32_t)getStatus;

/**
 * Returns the event ID associated with this event. Useful for matching the event received by
 * the listener to the original status returned when issuing the call, for example, calling
 * {@link com.verifone.commerce.payment.TransactionManager#reprintReceipt(Payment)} returns a
 * CommerceEvent containing an event ID, which will match the event ID received by the
 * CommerceListener when the receipt reprint is complete.
 */
- (nullable NSString *)getEventId;

/** The invoice ID for the transaction as a reference. */
- (nullable NSString *)getInvoiceId;

/** The transaction associated with this event. */
- (nullable VFITransaction *)getTransaction;

/**
 * If {@link #getType()} is {@link #TYPE}, returns the requested input type, else if this is
 * the {@link #REQUEST_TYPE}, returns the input type that is being requested.
 */
- (nullable NSNumber *)getInputType NS_SWIFT_NAME(__getInputType()) NS_REFINED_FOR_SWIFT;

/** Return the input subcommand that is being requested */
- (nullable NSNumber *)getInputSubcommand NS_SWIFT_NAME(__getInputSubcommand()) NS_REFINED_FOR_SWIFT;

/**
 * Returns the signature image. When {@link #getType()} is {@link #REQUEST_TYPE}, 
 * then this will only have a value if the InputSubcommand is SIGNATURE_PROVIDED. 
 * When {@link #getType()} is {@link #RECEIVED_TYPE}, this will only have a value 
 * if the InputType is SIGNATURE.
 */
- (nullable VFIImage *)getSignature;

/**
 * If {@link #getType()} is {@link #TYPE}, returns the default value from the original request,
 * otherwise this returns the requested default value.
 */
- (nullable NSString *)getDefaultValue;

/** Returns the current {@link RequestParameters} if this is of type {@link #REQUEST_TYPE}. */
- (nullable VFIRequestParameters *)getRequestParameters;

/**
 * If {@link #getType()} is {@link #TYPE}, returns the values as collected by the terminal,
 * otherwise this will be null.
 */
- (nullable VFIValues *)getValues;

/** Generates response for UserInputEvent */
- (nullable VFIUserInputEventResponse *)generateUserInputEventResponse;

/** Get InternalData - mainly for legacy POS support */
- (nullable NSString *)getInternalData;

@end
